;;;-*- Mode: LISP; Package: CL-USER; -*-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; YstokSQL - Common Lisp ODBC interface - Installation scripts

(in-package :cl-user)

;;; Back-ends types, for which the corresponding functionality is included into
;;; the resulting image or delivered application.
(pushnew :access *features*)
(pushnew :oracle *features*)
(pushnew :postgresql *features*)
(pushnew :sqlite3 *features*)

#+lispworks
(progn
  ;(load (lw:current-pathname "ylib/defsys.lisp"))
  ;(lw:compile-system 'YSTOK-LIBRARY :load t)

  (unless (sys:featurep :ylib)
    (error "Ystok-Library is required for YstokSQL!"))

  ;(load (lw:current-pathname "local-time/defsys.lisp"))
  ;(lw:compile-system 'LOCAL-TIME :load t)

  (load (merge-pathnames "defsys.lisp" *load-truename*))
  (lw:compile-system 'YSQL :load t :force nil) ; use :force T if compile troubles

  ;(load (merge-pathnames "tests/defsys.lisp" *load-truename*))
  ;(lw:compile-system 'YSQL.TESTS :load t)
)

#| ASDF-based
(load (merge-pathnames "ylib/ystok-library.asd" *load-truename*))
(load (merge-pathnames "ysql.asd" *load-truename*))
(load (merge-pathnames "ysql-tests.asd" *load-truename*))
(load (merge-pathnames "acl-compat/acl-compat.asd" *load-truename*))
(asdf:operate 'asdf:load-op :ysql)
(asdf:operate 'asdf:load-op :ysql-tests)
|#
