;;; -*- Mode: Lisp; -*-
;;; YstokSQL - Common Lisp ODBC interface 
;;; Copyright (c) 2002-2006 Dr. Dmitriy Ivanov. All rights reserved.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; MySQL database - Specialization for SQL expressions and types

(in-package :ystok.sql.sys)

(defmethod output-sql ((expr string) (database mysql-mixin))
 ;;; Construct character string literal and escape backslashes
  (write-char #\' *sql-stream*)
  (loop for char across string
        if (char= char #\') do (write-char #\' *sql-stream*)
        else if (char= char #\\) do (write-char #\\ *sql-stream*)
        do (write-char char *sql-stream*))
  (write-char #\' *sql-stream*))


(defmethod output-sql ((expr sql-insert-exp) (database mysql-mixin))
  (with-slots (into attributes values query) expr
    (write-string "REPLACE INTO " *sql-stream*)
    ;(typecase into
    ;  (symbol (write-sql-identifier into *sql-stream* database))
    ;  (string (write-sql-identifier into *sql-stream* database))
    (output-sql into database)
    (when attributes
      (write-char #\Space *sql-stream*)
      (output-sql attributes database))
    (when values
      (write-string " VALUES " *sql-stream*)
      (output-sql values database))
    (when query
      (write-char #\Space *sql-stream*)
      (output-sql query database))))
