;;; Collection of example commands tested in LWW 4.4 against MS Access

;(require :sql "sql:sql;sql-system.lisp")
;(require :odbc "sql:odbc;odbc-system.lisp") 

(lw:load-system 'YSQL)

;(use-package :sql)
(setq ys::*compile-for-lazyload* t) ; no need to always put [identifier] under evaluation
(sql:enable-sql-reader-syntax)
(sql:disable-sql-reader-syntax)

(sql:initialize-database-type :database-type :odbc)
(sql:initialize-database-type :database-type :access)
(sql:find-environment :access)

(sql:connect nil)
(setq a (sql:connect "Jet352" :autocommit t)) ; Jet 3.5 = doesn't work on Win2K
(setq a (sql:connect '("Sample" :user "admin") :autocommit t))
(setq a (sql:connect '("Jet4" :user "admin") :autocommit t))
(setq db (sql:connect "sample" :if-exists :warn-old)) ;:user-id "admin" :autocommit t
#P"e:/lisp/test/ysqltest.mdb"

;;; via DriverConnect
(setq a (sql:connect nil :autocommit t :if-exists :warn-old))	; display dialog
(setq a (sql:connect #P"e:/lisp/test/ysqltest4.mdb"		; short form
                     :database-type :access  :if-exists :new))
(setq a (sql:connect "Jet4" :autocommit t :if-exists :warn-old	; with driver-av-pairs
                     :driver-av-pairs '((:PageTimeout 6))))
(setq a (sql:connect nil :if-exists :new
           :driver-av-pairs `((:dbq "D:\\MsOffice.97\\Office\\Samples\\Northwind.mdb")
                              (:driver ,odbc::*access-driver*))))
(setq a (sql:connect nil :if-exists :new
           :driver-av-pairs `((:dbq "E:\\Projects\\Maersk\\Chivas\\ChiData.mdb")
                              (:driver ,odbc::*access-driver*))))
(setq a (sql:connect nil :if-exists :new
           :driver-av-pairs `((:dbq "E:\\Projects\\Arava\\2002\\arava.mdb")
                              (:driver ,odbc::*access-driver*))))

(setq a (sql:connect nil :if-exists :new
           :driver-av-pairs `((:dbq "E:\\Projects\\Maersk\RMDS\\RmData.mdb")
                              (:driver ,odbc::*access-driver*))))
(setq a (sql:connect nil :database-type :access	 ; more than 148 characters in pathname
           :driver-av-pairs `((:dbq "c:\\123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 ab.mdb"))))


(setq a sql:*default-database*)

(sql:connected-databases)

(sql:start-sql-recording)
(sql:delete-sql-stream *standard-output* :type :all)
(sql:start-sql-recording :type :result)
(setq stm (open #P"sql.log" :direction :output :if-exists :append))
(sql:add-sql-stream stm)
(sql:list-sql-streams)
(sql:delete-sql-stream stm)
(close stm)
(sql:stop-sql-recording :type :all)

(sql:find-database (sql:database-name a) :database-type (sql.sys:db-type a))

(sql:disconnect :database a)
(sql.sys::disconnect-all-databases)

(odbc::%sql-free-handle :hdbc (odbc::hdbc db))
(odbc::%sql-free-handle :henv (odbc::henv db))
(setf (odbc::henv db) nil)

;;; Environment attributes
(odbc::%sql-get-attribute :henv (odbc::henv db) odbc::SQL_ATTR_CONNECTION_POOLING)
(odbc::%sql-get-attribute :henv (odbc::henv a) odbc::SQL_ATTR_ODBC_VERSION)
;(odbc::%sql-get-attribute :henv (odbc::henv db) odbc::SQL_ATTR_OUTPUT_NTS)

;;; Connection attributes
(odbc::%sql-get-attribute :hdbc ffc:+sql-null-handle+ odbc::SQL_ATTR_TRACEFILE)
(odbc::%sql-get-attribute :hdbc (odbc::hdbc sql:*default-database*) odbc::SQL_ATTR_CURRENT_CATALOG)
(odbc::%sql-get-attribute :hdbc (odbc::hdbc db) odbc::SQL_ATTR_QUIET_MODE)
(odbc::%sql-get-attribute :hdbc (odbc::hdbc db) odbc::SQL_ATTR_ACCESS_MODE) ;SQLUINTEGER
(odbc::%sql-get-attribute :hdbc (odbc::hdbc db) odbc::SQL_ATTR_TXN_ISOLATION)
(odbc::%sql-get-attribute :hdbc (odbc::handle sql:*default-database*) odbc::SQL_ATTR_AUTOCOMMIT)
(odbc::%sql-get-attribute :hdbc (odbc::handle a) odbc::SQL_ATTR_CONNECTION_TIMEOUT)
;=> Not impelmenented
(odbc::%sql-get-attribute :hdbc (odbc::handle a) odbc::SQL_ATTR_LOGIN_TIMEOUT)
;=> Not impelmenented

;;; Diagnostics
(multiple-value-list
 (odbc::%sql-get-diag-record :hdbc (odbc::handle sql:*default-database*) 1))

(odbc::%sql-get-diag-field :hdbc (odbc::handle sql:*default-database*)
                           odbc::SQL_DIAG_RETURNCODE)
(odbc::%sql-get-diag-field :hdbc (odbc::handle sql:*default-database*)
                           odbc::SQL_DIAG_NUMBER)
(odbc::%sql-get-diag-field :hdbc (odbc::handle sql:*default-database*)
                           odbc::SQL_DIAG_SQLSTATE)
(mapcar (lambda (attribute)
          (odbc::%sql-get-diag-field ;:hdbc (odbc::handle sql:*default-database*)
                                     :hstmt hstmt
                                     attribute))
        `(,odbc::SQL_DIAG_RETURNCODE
          ,odbc::SQL_DIAG_NUMBER           
          ,odbc::SQL_DIAG_ROW_COUNT
          ,odbc::SQL_DIAG_SQLSTATE
          ,odbc::SQL_DIAG_NATIVE
          ,odbc::SQL_DIAG_MESSAGE_TEXT
          ,odbc::SQL_DIAG_DYNAMIC_FUNCTION
          ,odbc::SQL_DIAG_CLASS_ORIGIN
          ,odbc::SQL_DIAG_SUBCLASS_ORIGIN
          ,odbc::SQL_DIAG_CONNECTION_NAME
          ,odbc::SQL_DIAG_SERVER_NAME
          ,odbc::SQL_DIAG_DYNAMIC_FUNCTION_CODE
         ))

(mapcar (lambda (attribute)
          (odbc::%sql-get-diag-field :hstmt hstmt
                                     attribute))
        `(,odbc::SQL_DIAG_CURSOR_ROW_COUNT	;header
          ,odbc::SQL_DIAG_ROW_NUMBER
          ,odbc::SQL_DIAG_COLUMN_NUMBER))

(odbc::%sql-get-attribute :hdbc (odbc::hdbc sql:*default-database*) 34)
(sql:open-cursor [select [abracadabra] :from [tab]])
(sql:execute-command "CREATE VIEW abracadabra ON Non_existing")
(sql:execute-command "DROP VIEW abracadabra")

;;; CATALOG Functions
;;; get-info
(odbc::%get-info-result-type odbc::SQL_DBMS_NAME)
(odbc::db-get-info sql:*default-database* odbc::SQL_SERVER_NAME)
(odbc::db-get-info sql:*default-database* odbc::SQL_DBMS_NAME)
(odbc::db-get-info sql:*default-database* odbc::SQL_DBMS_VER)
; => "03.50.0000" or "04.00.0000"  - Jet version
(odbc::%sql-get-info (odbc::hdbc db) odbc::SQL_PROCEDURES)
(odbc::%sql-get-info (odbc::hdbc sql:*default-database*) odbc::SQL_ODBC_VER)
; Win2K => "03.52.0000" 
(odbc::%sql-get-info ystok.ffc:+null-ptr+ odbc::SQL_ODBC_VER)
;=>Invalid handle - Requires a connection handle, even not open.

(odbc::db-get-info sql:*default-database* odbc::SQL_PROCEDURES)
; Access,Oracle => "Y" (Access,Oracle)
(odbc::db-get-info sql:*default-database* odbc::SQL_DRIVER_ODBC_VER)
; Access => "03.51" (Jet 4) or "02.50" (Jet 3.5)
; Oracle => "03.51"
(odbc::db-get-info sql:*default-database* odbc::SQL_DRIVER_VER)
; Access => "04.00.6200" (Jet 4) or ? (Jet 3.5)
(odbc::db-get-info sql:*default-database* odbc::SQL_TXN_CAPABLE)
; Access => 2 (SQL_TC_ALL) ; can contain DDL statements and DML statements in any order
; Oracle => 3 (SQL_TC_DDL_COMMIT) ??
(odbc::db-get-info sql:*default-database* odbc::SQL_TXN_ISOLATION_OPTION)
; Access => 2 (SQL_TXN_READ_COMMITTED)
(odbc::db-get-info sql:*default-database* odbc::SQL_DEFAULT_TXN_ISOLATION) ; => 2
(odbc::db-get-info sql:*default-database* odbc::SQL_MULTIPLE_ACTIVE_TXN)
; Access => "Y" supports more than one active transaction at the same time on more than one connection in the same environment

(odbc::db-get-info sql:*default-database* odbc::SQL_CATALOG_NAME)
(odbc::db-get-info sql:*default-database* odbc::SQL_CATALOG_USAGE)
; Access => 13 (SQL_CU_)= 1(DML_STATEMENTS) + 4(TABLE_DEFINITION) + 8(INDEX_DEFINITION)
(odbc::db-get-info sql:*default-database* odbc::SQL_CATALOG_TERM)
; Access => "DATABASE"
(odbc::db-get-info sql:*default-database* odbc::SQL_CATALOG_LOCATION)
; Access => 1 SQL_CL_START
; Oracle => 2 SQL_CL_END
(odbc::db-get-info sql:*default-database* odbc::SQL_CATALOG_NAME_SEPARATOR)
; Access => "." 
; Oracle => ?
; Text => "\\"
(odbc::db-get-info sql:*default-database* odbc::SQL_MAX_CATALOG_NAME_LEN)
; Access => 260

(odbc::db-get-info sql:*default-database* odbc::SQL_SCHEMA_USAGE)	;=> 0
(odbc::db-get-info sql:*default-database* odbc::SQL_SCHEMA_TERM)	;=> ""
(odbc:db-get-info sql:*default-database* odbc::SQL_MAX_SCHEMA_NAME_LEN)	;=> 0

(odbc:db-get-info sql:*default-database* odbc::SQL_IDENTIFIER_QUOTE_CHAR);=> "`"
(odbc:db-get-info sql:*default-database* odbc::SQL_SPECIAL_CHARACTERS)
;=> "~@#$%^&*_-+=\\}{\"';:?/><,.![]|"
(odbc:db-get-info sql:*default-database* odbc::SQL_MAX_TABLE_NAME_LEN)	;=> 64
(odbc::db-get-info a odbc::SQL_NULL_COLLATION)				;=> 1 = SQL_NC_LOW

(odbc:db-get-info sql:*default-database* odbc::SQL_GETDATA_EXTENSIONS)
; Access => 15 = SQL_GD_ANY_COLUMN | SQL_GD_ANY_ORDER | SQL_GD_BLOCK | SQL_GD_BOUND
(odbc:db-get-info sql:*default-database* odbc::SQL_NEED_LONG_DATA_LEN) ;=> nil

(odbc::db-get-info sql:*default-database* odbc::SQL_PARAM_ARRAY_ROW_COUNTS)
; Access => 2 SQL_PARC_NO_BATCH - only one row count available
(odbc::db-get-info sql:*default-database* odbc::SQL_PARAM_ARRAY_SELECTS)
; Access => 2 SQL_PAS_NO_BATCH - There is only one result set available

(odbc::db-get-info sql:*default-database* odbc::SQL_OJ_CAPABILITIES)
; Access => 83 = SQL_OJ_LEFT(1)+SQL_OJ_RIGHT(2)+SQL_OJ_NOT_ORDERED(16)+
;              + SQL_OJ_ALL_COMPARISON_OPS(64)

(odbc::db-get-info sql:*default-database* odbc::SQL_CURSOR_COMMIT/ROLLBACK_BEHAVIOR)
; Access => 1 = (SQL_CB_CLOSE) 
; Closes cursors but preserve plans for prepared stmts on manual commit/rollback
; Nevertheless, in autocommit mode Access acts like SQL_CB_PRESERVE, i.e. does not
; close a cursor after SQLSetPos()
(odbc::db-get-info sql:*default-database* odbc::SQL_CURSOR_SENSITIVITY)
; Access => 0 SQL_UNSPECIFIED
; It is unspecified whether cursors on the statement handle make visible the changes
; made to a result set by another cursor within the same transaction.
(odbc::db-get-info sql:*default-database* odbc::SQL_ROW_UPDATES)
; Access => "N", cannot detect updates to data
; Oracle => "Y"
(odbc::db-get-info sql:*default-database* odbc::SQL_BOOKMARK_PERSISTENCE)
; Access => 80 = SQL_BP_UPDATE(#x00000010) + SQL_BP_SCROLL(#x00000040)
(odbc::db-get-info sql:*default-database* odbc::SQL_SCROLL_OPTIONS)
; Access => 19 = SQL_SO_FORWARD_ONLY | SQL_SO_STATIC | SQL_SO_KEYSET_DRIVEN
(odbc::db-get-info sql:*default-database* odbc::SQL_SCROLL_CONCURRENCY)
; Access => 11 = SQL_SCCO_READ_ONLY(1) + SQL_SCCO_LOCK(2) + SQL_SCCO_OPT_VALUES(8)

(odbc::db-get-info sql:*default-database* odbc::SQL_STATIC_SENSITIVITY)
; Access => 7 = SQL_SS_ADDITIONS(1) + SQL_SS_DELETIONS(2) + SQL_SS_UPDATES(4)
; 	Indicates whether a cursor is sensitive to changes made by another cursor.

(odbc::db-get-info sql:*default-database* odbc::SQL_DYNAMIC_CURSOR_ATTRIBUTES1) ; => 0
(odbc::db-get-info sql:*default-database* odbc::SQL_DYNAMIC_CURSOR_ATTRIBUTES2) ; => 0
(odbc::db-get-info sql:*default-database* odbc::SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES1)
; Access => 1 SQL_CA1_NEXT
(odbc::db-get-info sql:*default-database* odbc::SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES2)
; Access => 1 SQL_CA2_READ_ONLY_CONCURRENCY
;	Whether cursors can detect their own updates, deletes, and inserts. 
(odbc::db-get-info sql:*default-database* odbc::SQL_KEYSET_CURSOR_ATTRIBUTES1)
; Access => 990799 = #xF1E4F (SQL_CA1_)
;	= NEXT(1) + ABSOLUTE(2) + RELATIVE(4) + BOOKMARK(8)
;	+ LOCK_NO_CHANGE
;	+ POS_POSITION + POS_UPDATE + POS_DELETE + POS_REFRESH
;	+BULK_ADD+BULK_UPDATE_BY_BOOKMARK+BULK_DELETE_BY_BOOKMARK+BULK_FETCH_BY_BOOKMARK
(odbc::db-get-info sql:*default-database* odbc::SQL_KEYSET_CURSOR_ATTRIBUTES2)
; Access => 127 = #x7F (SQL_CA2_)
;	= READ_ONLY_CONCURRENCY(1) + LOCK_CONCURRENCY(2)
;	+ OPT_ROWVER_CONCURRENCY(4) + OPT_VALUES_CONCURRENCY(8)
;	+ SENSITIVITY_ADDITIONS(16)+SENSITIVITY_DELETIONS(32) + SENSITIVITY_UPDATES(64)
(odbc::db-get-info sql:*default-database* odbc::SQL_STATIC_CURSOR_ATTRIBUTES1)
; Access => 528911 = #x8120F (SQL_CA1_)
;	= NEXT(1) + ABSOLUTE(2) + RELATIVE(4) + BOOKMARK(8)
;	+ POS_POSITION + POS_REFRESH + BULK_FETCH_BY_BOOKMARK
(odbc::db-get-info sql:*default-database* odbc::SQL_STATIC_CURSOR_ATTRIBUTES2)
; Access => 1 SQL_CA2_READ_ONLY_CONCURRENCY

(odbc::db-get-info sql:*default-database* odbc::SQL_NUMERIC_FUNCTIONS)
(odbc::db-get-info sql:*default-database* odbc::SQL_SQL92_NUMERIC_VALUE_FUNCTIONS)
(odbc::db-get-info sql:*default-database* odbc::SQL_SQL_CONFORMANCE)
;=> 1 = SQL_SC_SQL92_ENTRY (CAST is not supported)

(format nil "#x~x" 528911)

(defun list-info (database stream)
  (let ((constants (remove-if (complement #'constantp) (apropos-list "SQL_" :odbc))))
    ;(loop for key being the hash-keys of odbc::*get-info-result-types*
    ;          using (hash-value value)
    (loop for c in (sort constants #'string-lessp)
          for value = (ignore-errors (odbc::db-get-info database (symbol-value c)))
          when value
          do (format stream "~&~A -> ~S" c value))))

;(list-info db t)

(sql:status t)
(sql:list-tables)
(sql:list-tables :database a :schema :all)
(sql.sys:db-describe-tables a "tab%" :table-type "VIEW,TABLE")
(sql:table-exists-p "msysobjects" :schema :all)

(sql:list-attributes "tab" :database a)
(odbc::db-describe-columns arep "tab")
; Access ODBC 4.0 -   REMARKS    (  )
; , ,  \0  , ..  ,   .
(("E:\\Lisp\\Test\\sample" NIL "tab" "id" 4 "COUNTER" 10 4 0 10 0 "id description g?? ????????" NIL 4 NIL NIL 1 "NO" 1)
 ("E:\\Lisp\\Test\\sample" NIL "tab" "Text_" 12 "VARCHAR" 50 100 NIL NIL 1 "Text_ description" NIL 12 NIL 100 2 "YES" 2)
 ("E:\\Lisp\\Test\\sample" NIL "tab" "Memo_" -1 "LONGCHAR" 2147483647 2147483647 NIL NIL 1 "Memo_ description" NIL -1 NIL 2147483647 3 "YES" 3)
 ("E:\\Lisp\\Test\\sample" NIL "tab" "Boolean_" -7 "BIT" 1 1 0 NIL 0 "Boolean_ description" NIL -7 NIL NIL 4 "NO" 4)
 ("E:\\Lisp\\Test\\sample" NIL "tab" "Currency_" 2 "CURRENCY" 19 21 4 10 1 "Currency_ description" NIL 2 NIL NIL 5 "YES" 5)
 ("E:\\Lisp\\Test\\sample" NIL "tab" "DateTime_" 93 "DATETIME" 19 16 0 NIL 1 "DateTime_ description" NIL 9 3 NIL 6 "YES" 6)
 ("E:\\Lisp\\Test\\sample" NIL "tab" "Byte_" -6 "BYTE" 3 1 0 10 1 "Byte_ description ??d" NIL -6 NIL NIL 7 "YES" 7)
 ("E:\\Lisp\\Test\\sample" NIL "tab" "Short_" 5 "SMALLINT" 5 2 0 10 1 "Short_ description" NIL 5 NIL NIL 8 "YES" 8)
 ("E:\\Lisp\\Test\\sample" NIL "tab" "Long_" 4 "INTEGER" 10 4 0 10 1 "Long_ description" NIL 4 NIL NIL 9 "YES" 9)
 ("E:\\Lisp\\Test\\sample" NIL "tab" "Single_" 7 "REAL" 24 4 NIL 2 1 "Single_ description" NIL 7 NIL NIL 10 "YES" 10)
 ("E:\\Lisp\\Test\\sample" NIL "tab" "Double_" 8 "DOUBLE" 53 8 NIL 2 1 "Double_ description" NIL 8 NIL NIL 11 "YES" 11)
 ("E:\\Lisp\\Test\\sample" NIL "tab" "Ole_" -4 "LONGBINARY" 1073741823 1073741823 NIL NIL 1 "Ole_ description" NIL -4 NIL 1073741823 12 "YES" 12)) 

(sql:attribute-type "Datetime_" "tab" :database a)
(sql:attribute-type "Currency_" "tab" :database a)
(sql:attribute-type [EmployeeID] [tblEmployee])

(odbc::%sql-func-exists a odbc::SQL_API_SQLGETTYPEINFO)
(odbc::%initialize-type-info a)
(odbc::db-describe-type a 0) ; Jet 4.0 =>
(("GUID" -11 36 "'" "'" NIL 1 0 0 NIL 0 NIL NIL NIL NIL -11 NIL NIL NIL)
 ("BIT" -7 1 NIL NIL NIL 0 0 2 NIL 0 NIL NIL 0 0 -7 NIL NIL NIL)
 ("BYTE" -6 3 NIL NIL NIL 1 0 2 1 0 0 NIL 0 0 -6 NIL 10 NIL)
 ("LONGBINARY" -4 1073741823 "0x" NIL NIL 1 0 0 NIL 0 NIL NIL NIL NIL -4 NIL NIL NIL)
 ("VARBINARY" -3 255 "0x" NIL "length" 1 0 0 NIL 0 NIL NIL NIL NIL -3 NIL NIL NIL)
 ("BINARY" -2 255 "0x" NIL "length" 1 0 0 NIL 0 NIL NIL NIL NIL -2 NIL NIL NIL)
 ("LONGCHAR" -1 2147483647 "'" "'" NIL 1 0 0 NIL 0 NIL NIL NIL NIL -1 NIL NIL NIL)
 ("CHAR" 1 255 "'" "'" "length" 1 0 3 NIL 0 NIL NIL NIL NIL 1 NIL NIL NIL)
 ("CURRENCY" 2 19 NIL NIL NIL 1 0 2 0 1 0 NIL 4 4 2 NIL 10 NIL)
 ("INTEGER" 4 10 NIL NIL NIL 1 0 2 0 0 0 NIL 0 0 4 NIL 10 NIL)
 ("COUNTER" 4 10 NIL NIL NIL 0 0 2 0 0 1 NIL 0 0 4 NIL 10 NIL)
 ("SMALLINT" 5 5 NIL NIL NIL 1 0 2 0 0 0 NIL 0 0 5 NIL 10 NIL)
 ("REAL" 7 24 NIL NIL NIL 1 0 2 0 0 0 NIL NIL NIL 7 NIL 2 NIL)
 ("DOUBLE" 8 53 NIL NIL NIL 1 0 2 0 0 0 NIL NIL NIL 8 NIL 2 NIL)
 ("VARCHAR" 12 255 "'" "'" "length" 1 0 3 NIL 0 NIL NIL NIL NIL 12 NIL NIL NIL)
 ("DATETIME" 93 19 "#" "#" NIL 1 0 2 NIL 0 NIL NIL 0 0 9 3 NIL NIL))
(odbc::%get-type-descriptor a odbc::SQL_TYPE_DATE)	; => nil
(odbc::%get-type-descriptor a odbc::SQL_TYPE_TIMESTAMP)
(odbc::%get-type-descriptor a odbc::SQL_BIGINT)

(ODBC::%sql-get-functions (odbc::handle a) odbc::SQL_API_SQLDESCRIBEPARAM)
(odbc::%sql-func-exists a odbc::SQL_API_SQLDESCRIBEPARAM) ; Access => nil
(odbc::%sql-func-exists a odbc::SQL_API_SQLPARAMDATA) 	  ; Access => t
(odbc::%sql-func-exists a odbc::SQL_API_SQLTABLES)
(odbc::%sql-func-exists a odbc::SQL_API_SQLBULKOPERATIONS) ; Access => t

(odbc::%sql-func-exists a odbc::SQL_API_SQLSPECIALCOLUMNS) ; Access => t
(odbc::db-describe-special-columns a "Bills" :type odbc::SQL_BEST_ROWID
                                   :scope odbc::SQL_SCOPE_CURROW)
; => ((0 "s_GUID" -11 "GUID" 36 16 NIL 1)
;;    (0 "BillID" 4 "COUNTER" 10 4 0 1))  ; SQL_SCOPE_CURROW ... SQL_PC_NOT_PSEUDO
(odbc::db-describe-special-columns a "Bills" :type odbc::SQL_BEST_ROWID
                                   :scope odbc::SQL_SCOPE_SESSION) ;=>nil
;;     ,    - !

(odbc::db-describe-special-columns a "tab" :type odbc::SQL_ROWVER
                                           :scope odbc::SQL_SCOPE_CURROW) ;=>nil
(odbc::db-describe-special-columns a "Table2" :type odbc::SQL_BEST_ROWID
                                              :scope odbc::SQL_SCOPE_CURROW
                                              :nullable t) ; :nullable nil -  
; => ((0 "a2" 4 "INTEGER" 10 4 0 1) (0 "a1" 12 "VARCHAR" 50 50 NIL 1)) 
(odbc::db-describe-special-columns a "Table2" :type odbc::SQL_BEST_ROWID
                                              :scope odbc::SQL_SCOPE_TRANSACTION) ;=>nil
(odbc::db-describe-special-columns a "Table2" :type odbc::SQL_BEST_ROWID
                                              :scope odbc::SQL_SCOPE_SESSION) ;=>nil

(odbc::%sql-func-exists a odbc::SQL_API_SQLPRIMARYKEYS) ; Access => nil
(odbc::db-describe-primary-keys a nil nil "tab") ;   MS Access

(odbc::%sql-func-exists a odbc::SQL_API_SQLFOREIGNKEYS) ; Access => nil
(odbc::db-describe-foreign-keys a "degrees" "physicians")

(odbc::%sql-func-exists a odbc::SQL_API_SQLSTATISTICS)  ; Access => t
(odbc::db-describe-statistics a "tab")
; => (("E:\\Lisp\\Test\\sample" NIL "tab" NIL "tab" NIL 0 NIL NIL NIL 58 2 NIL)
      ("E:\\Lisp\\Test\\sample" NIL "tab" 0 "tab" "PrimaryKey" 3 1 "id" "A" 21 1 NIL)
      ("E:\\Lisp\\Test\\sample" NIL "tab" 1 "tab" "id" 3 1 "id" "A" 1 1 NIL))
(sql.sys:db-list-indexes a "tab")
(sql.sys::list-indexes :database a :owner "admin")
(sql.sys:index-exists-p "id" :database a)
(sql.sys:index-exists-p [PrimaryKey] :database a :on "tab")


;;; DDL

(sql:execute-command
   "CREATE TABLE TYPE_TABLE (t_int INTEGER, t_float DOUBLE, t_str VARCHAR(30))")

(setq e [create-table [Table1]
  `(([id] integer :primary-key)
    ([tab-id] integer         ; :default 2 - Jet 3.5 not supported
      :constraint [table1-id2]
      :references [tab] [id]) ; :on-update :cascade - Jet 4 only
    ;([text-moo] (string 32) :default "Moo"
    ;                                 :check ,[and [> [id] 0] [>= [text-moo] "m%"]]))
    ([bin] bit-vector)
    ([l] integer))
   :constraints
   '(([fk_table1_l_tab_id] :foreign-key ([l]) :references [tab] [id])
    ; (:check ,[> [tab-id] 5]) ; MSA not supported
    )])
(sql:drop-table [Tab222] :if-does-not-exist :ignore)
(sql:drop-table [Table1])
(sql:create-table [Table1]
  `(([id] integer :primary-key)
    ([tab-id] integer         ; :default 2 - Jet 3.5 not supported
      :constraint [table1-id2]
      :references [tab] [id]) ; :on-update :cascade - Jet 4 only
    ;([text-moo] (string 32) :default "Moo"
    ;                                 :check ,[and [> [id] 0] [>= [text-moo] "m%"]]))
    ([bin] bit-vector)
    ([l] integer)
    (:constraint [fk_table1_l_tab_id] :foreign-key ([l]) :references [tab] [id])
    ; (:check ,[> [tab-id] 5]) ; MSA not supported
   )
)
(sql:insert-records :into [Table1] :attributes '([id] [bin])
                :values (list 23 #*0011001000110011))
(setq b (make-array 3 :element-type '(unsigned-byte 8)
            :initial-contents `(,(char-code #\2) ,(char-code #\1) ,(char-code #\0))))
(sql:insert-records :into [Table1] :attributes '([id] [bin])
                    :values (list 210 b))
(sql:select [id] [bin] :from [table1])
(sql:select [id] [the '(vector unsigned-byte) [bin]] :from [table1])
(sql:select [id] [bin :type string] :from [table1])

(sql:create-table 'ThirdTable2 (FirstName CHAR(10), LastName LONGTEXT))
(execute-command "CREATE TABLE ThirdTable4 (s short REFERENCES ThirdTable3(s) ON UPDATE CASCADE );")

(sql:alter-table [Table1] :add '(([id4] integer) ([id5] integer)))
(sql:alter-table [Table1] :drop '([id3] [id4] [id5]))
;; Jet 3.5: add and drop don't work together
(sql:alter-table [Table1] :add '(([id3] integer)) :drop '([id2])) 
(sql:alter-table [Table1] :drop '((:constraint [ct_tab_long_table1_l])))

(sql:alter-table [Table1]
  :add '(([id3] integer)
         (:constraint [fk_id3] :foreign-key ([id3]) :references [tab] [id])))
(sql:alter-table [Table1] :drop '((:constraint [fk_id3]) [id3]))
(sql:alter-table [Table1] :modify '(([l] integer))); (string 25))))


(sql:create-index [id2d2_ix] :on [Table1] :attributes '([id2] [d2 :desc]) :unique t
                 :with :ignore-null))
(sql:drop-index [id2d2_ix] :on [Table1])

(sql:create-view [v3] :as [select [id] [text_] :from [tab]])
(odbc::db-describe-tables a nil nil "v3" nil)
(sql:drop-view [v3]) 	; Jet 3.5 is not supported
(sql:execute-command "DROP VIEW LENINS_GROUP")	; niether supported in 3.5 nor 4.0

(sql:commit)


;;; DML
(defun random-string (size)
  (let ((str (make-string size))) ; :element-type 'base-character)))
    (dotimes (i size)
      (setf (char str i) (code-char (+ 97 (random 26)))))
    str))

(sql:commit)
(sql:insert-records :into [tab2]
                    :attributes '([id] [text2_])
                    :values (list 10 "  "))
(sql:insert-records :into [tab2]
                    :av-pairs '(([id] 11) ([text2_] "  ")))
(sql:insert-records :into [tab2]
                    :attributes '([id] [text2_])
                    :query [SELECT ["tt" ID] ["tt" TEXT_]
                                   :FROM [tab "tt"]
                                   :where [< ["tt" ID] 15]])
(sql:insert-records :into [tab2] :attributes [id] :values 40)
(setq n 10)
(sql:delete-records :from [Tab2] :where [>= [ID] n]])
(sql:update-records [tab2] :attributes '([text2_]) :values " "
                           :where [>= [ID] 5])
(sql:update-records [tab2] :attributes [text2_] :values " "
                           :where [= [ID] 5])

(sql:execute-command "INSERT INTO TYPE_TABLE VALUES (-4,-8.0E-8,'-8.0E-8')")

;;; Queries

(setq s [select [id] :as [i] [first [Text_]] :from [tab] :group-by [id]
                   :order-by '([id] :desc [first [Text_]])])

(sql:query "select {fn BAND(Short_,Long_)} as b FROM tab")

(sql:query "select  emplid AND NOT emplid as b FROM employee")

(sql:query [select [*] :from [tab2] :limit 3]
           :result-types '(string string lt:date))  ; coerce ID to string
(sql:query [select [*] :from [tab2]])
(sql:query [select [id] :as [i] [first [Text_]] :from [tab] :group-by [id]
                   :order-by `(,[id] :desc ,[first [Text_]])])
(sql:query [select [id :as i] [Text_] [Currency_ :type double-float] :from [tab]
                   :order-by '([id :desc] [Text_])])
(sql:select [Currency_]
    [Currency_ :type ratio :as c_ratio]
    [Currency_ :type double-float :as c_dfloat]
    [Currency_ :type single-float :as c_sfloat]
    [Currency_ :type integer :as c_integer]
    [Currency_ :type :smallint :as c_smallint] ; [state 01S07 info 13] Fract.truncation
    [Currency_ :type string :as c_string]
    :from [tab] :limit nil)
;=>(327783/25 327783/25 13111.320000000005 327783/25 "#<unreadable>" 13111 "13111.3200")
(sql:select [Long_]
    [Long_ :type ratio :as l_ratio]
    [Long_ :type double-float :as l_dfloat]
    [Long_ :type single-float :as l_sfloat]
    [Long_ :type integer :as l_integer]
 ;[Long_ :type :smallint :as l_smallint] ;[state 22003 error 34]Numeric value out of range
    [Long_ :type string :as l_string]
    :from [tab] :limit nil)
;=>(640000 640000 640000.0 640000.0 640000 "640000")
(sql:select [Double_]
    [Double_ :type (ratio 19 4) :as d_ratio]
    [Double_ :type double-float :as d_dfloat]
    [Double_ :type single-float :as d_sfloat]
    [Double_ :type integer :as d_integer]
    [Double_ :type :smallint :as d_smallint]	; [state 01S07 info 13] Fract.truncation
    [Double_ :type string :as d_string]
    :from [tab] :limit nil)
;=>(5555.66666 27778333/5000 5555.66666 5555.66650390625 "#<unreadable>" 5555 "5555.66666")

(sql:query "SELECT ID FROM tab" :flatp t)
(sql:select [text_] :from [tab] :flatp t :distinct t)
(sql:query  [select [id] [text_] :from [tab] :order-by [id :desc] :flatp nil])
(sql:map-query 'nil (lambda (id text) (format t "~&id=~S txt=~S" id text)
                                       id)
               [select [id] [text_] :from [tab] :order-by [id :desc] :flatp nil])

(sql:print-query "SELECT Text_,Long_,Single_ FROM tab"
                 :sizes t ;'(30 5 10)
                 :formats '("~vA" "~4D" "~5,2F"))
                 :database a)
(time (sql:query "SELECT Text_,Long_,Single_,Memo_ FROM tab" :database a))
(sql:query "SELECT TOP 5 ID,Boolean_,DateTime_,Byte_,Short_,Double_ FROM tab" :database a)
(sql:do-query ((txt b c d m  &rest rest)
               "SELECT TOP 5 Text_,Byte_,Currency_,DateTime_,Memo_ FROM tab"
               :database a)
  (format t "~&txt=~S:~S b=~S:~S c=~S:~S d=~S m=~S rest=~S" 
    txt (type-of txt) b (type-of b) c (type-of c) d m rest))
;=>[ODBC state 22018 error 39] using database Sample.
;  [Microsoft][ODBC Microsoft Access Driver]
;  Invalid character value for cast specification on column number 3 (Currency_)
;; ,        . locale

;;; LWW:   double-float!
;;;a=640000:FIXNUM b=12.34:SINGLE-FLOAT c=5555.66666d0:DOUBLE-FLOAT rest=NIL
;;;a=536870913:BIGNUM b=43.21:SINGLE-FLOAT c=6666.5555d0:DOUBLE-FLOAT rest=NIL
(sql:do-query ((f1) "SELECT Ole_ FROM tab;" :database a)
  (format t "~&1=~S:~S" 
    f1 (type-of f1)))

(loop for (txt b c d  rest) being each record 
       of [SELECT [Text_] [Byte_] [Currency_] [DateTime_] [Memo_] :FROM [tab]]
       ;using (:database a)
      do (format t "~&txt=~S:~S b=~S:~S c=~S:~S d=~S rest=~S" 
                 txt (type-of txt) b (type-of b) c (type-of c) d rest))

(loop for record of-type vector being each record 
       of [SELECT [Text_] [Byte_] [Currency_] [DateTime_] [Memo_] :FROM [tab]]
       using (:database a)
      collect (copy-seq record))

(loop for (txt) being each record 
       of [SELECT [Text_] :FROM [tab] :flatp nil]
       do (format t "~&txt=~S:~S" txt (type-of txt)))

(sql:print-query [SELECT [Text_] [Byte_] [Currency_] [DateTime_] [Memo_] :FROM [tab]]
                 :titles '("txt" "Byte" "Currency" "DateTime" "Memo")
                 :sizes '(10 5 10 19 30))

(sql:do-query ((a b &rest rest)
           [select [*] :from [tab2]])
          (print (list a b)))


(do-query ((a1 a2) "SELECT a1,a2 FROM Table2")
  (format t "~&1=~S 2=~S" a1 a2))

(do-query ((a b) "SELECT Text_,Text2_ FROM outer_join;")
  (format t "~&a=~S:~S b=~S:~S" 
    a (type-of a) b (type-of b)))

(sql:select [*] :from [employee])
(sql:query [SELECT [emplid] [last_name] [married] :FROM [employee]])
(sql:query [SELECT [emplid] [last_name] [cast [married] :as :double] :FROM [employee]])

(select [count [id]] :from [tab2])
(setq e [cast [a] :as :integer])

;;; Northwind - Issue Q275058 - works fine (also works within Access 97)

(sql:query "SELECT Employees.LastName, Employees.FirstName, Orders.OrderID
FROM Employees LEFT OUTER JOIN Orders
ON ((Employees.EmployeeID = Orders.EmployeeID) and (Orders.ShipCity = 'Warszawa'))")
=>(("Davolio" "Nancy" 10792)
   ("Davolio" "Nancy" 10374)
   ("Fuller" "Andrew" NIL)
   ("Leverling" "Janet" NIL)
   ("Peacock" "Margaret" 11044)
   ("Peacock" "Margaret" 10906)
   ("Buchanan" "Steven" 10870)
   ("Suyama" "Michael" 10611)
   ("King" "Robert" NIL)
   ("Callahan" "Laura" 10998)
   ("Dodsworth" "Anne" NIL))
;; workaround - also works
(sql:query "SELECT Employees.LastName, Employees.FirstName, Orders.OrderID
FROM Employees LEFT JOIN [SELECT * FROM  Orders WHERE ShipCity = 'Warszawa']. AS Orders 
ON Employees.EmployeeID = Orders.EmployeeID")

;; Local-time
(setq rs (sql:query "SELECT TOP 5 ID,DateTime_ FROM tab" :database a))

(with-transaction
  (insert-records :into [foo bar] :values '(17 "jazz")))
(with-transaction
  (insert-records :into [foo baz] :values '(17 "Pacito d'Riveira")))

(select [id] :from [foo bar-baz])

(select [count [id]] :from [foo bar-baz])

(do-query ((a b)
           [select [*] :from [foo bar]])
          (print (list a b)))

(execute-query "select id from foo.bar union select id from foo.bar order by id desc")

;;; Diagnostics

(odbc::%make-diag-records :hstmt (odbc::handle aq))
(odbc::%sql-get-diag-field :hstmt (odbc::handle aq) odbc::SQL_DIAG_CURSOR_ROW_COUNT)
; Access => 0
(odbc::%sql-get-diag-field :hstmt (odbc::handle aq) odbc::SQL_DIAG_SERVER_NAME)
; Access => "Sample"
(odbc::%sql-get-diag-field :hstmt (odbc::handle aq) odbc::SQL_DIAG_CONNECTION_NAME)
; Access => ""
(odbc::%sql-get-diag-field :hstmt (odbc::handle aq) odbc::SQL_DIAG_ROW_NUMBER)

;;         .,
;;  update-records :
; [ODBC state HY000 error -1102] using database Sample.
; Message: [Microsoft][ODBC Microsoft Access Driver]
; Could not update; currently locked by user 'Admin' on machine 'DIGO'.

;;      .,  update-records :
; [ODBC state HY000 error -1611] using database Sample.
; Message: [Microsoft][ODBC Microsoft Access Driver]
; The Microsoft Jet database engine stopped the process because you and
; another user are attempting to change the same data at the same time.

;; a %sql-refresh-record (row-number =  =0), 
; [ODBC state 24000 error 0] using database Sample.
; Message: [Microsoft][ODBC Driver Manager] Invalid cursor state.

;;  SQLFetch()   (rowset-size/=0)   (rowset-size=0):
; [ODBC state HY109 info -1017] using database #<unknown>.
; Message: [Microsoft][ODBC Microsoft Access Driver] Record is deleted.
;; diag-row-number   !

(defun print-row-status-array (cursor)
  (with-slots (odbc::row-descriptor) cursor
    (with-slots (odbc::array-size odbc::current-row-status) odbc::row-descriptor
      (if (or (> odbc::array-size 1) (member (ystok.sql.sys:cursor-type cursor)
                                             '(:keyset-driven)))
          (dotimes (i odbc::array-size (format t "~&rows-fetched=~s"
                                       (odbc::desc-rows-processed odbc::row-descriptor)))
            (format t "~&row-status[~A]=~S" i
                    (case (odbc::desc-row-status odbc::row-descriptor i)
                      (#.odbc::SQL_ROW_SUCCESS 'odbc::SQL_ROW_SUCCESS)
                      (#.odbc::SQL_ROW_SUCCESS_WITH_INFO 'odbc::SQL_ROW_SUCCESS_WITH_INFO)
                      (#.odbc::SQL_ROW_UPDATED 'odbc::SQL_ROW_UPDATED)
                      (#.odbc::SQL_ROW_ADDED   'odbc::SQL_ROW_ADDED)
                      (#.odbc::SQL_ROW_ERROR   'odbc::SQL_ROW_ERROR)
                      (#.odbc::SQL_ROW_DELETED 'odbc::SQL_ROW_DELETED) 
                      (#.odbc::SQL_ROW_NOROW   'odbc::SQL_ROW_NOROW)
                      (otherwise (odbc::desc-row-status odbc::row-descriptor i)))))
          (format t "~&(array-size=1) : current-row-status=~S"
                  odbc::current-row-status)))))

;;; Cursors
(odbc::%sql-get-attribute :hdbc (odbc::handle sql:*default-database*) odbc::SQL_ATTR_AUTOCOMMIT)
(odbc::%sql-set-attribute :hdbc (odbc::handle sql:*default-database*) odbc::SQL_ATTR_AUTOCOMMIT odbc::SQL_AUTOCOMMIT_ON)
(odbc::%sql-get-attribute :hstmt (odbc::handle aq) odbc::SQL_ATTR_CONCURRENCY)
(odbc::%sql-get-attribute :hstmt (odbc::handle aq) odbc::SQL_ATTR_QUERY_TIMEOUT)
;=> Not impelmenented

(sql:execute-command "CREATE TABLE t_table (t_float double)" :database a)
(sql:execute-command "INSERT INTO t_table (t_float) VALUES (-8.0E-8)" :database a)
(setq aq3 (sql:open-cursor "SELECT t_float FROM t_table" :result-types '((string 30))
                            :database a))
(sql:fetch-rows aq3 :count 1 :flatp nil)

(setq aq (sql:open-cursor [select [id] [text_] [datetime_] [double_] [currency_] ;[memo_] ;[ole_]
                                  :from [tab] :distinct nil]
                          :cursor-type :keyset-driven
                          :concurrency :optimistic ;:lock
                          :rowset-size 1
                          :start-column 0
                          :database a)) 
(sql:fetch-rows  aq :count 3 :flatp nil)
(sql:fetch-item aq 2 :current t)
(sql:fetch-item aq :bookmark :current t)
(setq l (make-list 4))
(sql:fetch-into aq l :columns '([text_] "memo_") :start 2 :current t)
(sql:fetch-into aq l :start-column 2 :start 0 :current t)
(sql:fetch-rows  aq :count 4 :flatp nil :ignore-columns '(:bookmark))
(setq vo (make-array 4))
(sql:fetch-into aq vo :columns '([text_]) :start 2 :current t)

(odbc::current-row-status aq)
(sql:set-cursor-position aq :prior)
(sql:set-cursor-position aq :next)
(sql:set-cursor-position aq :absolute :offset 0)
(odbc::set-cursor-position aq :relative :offset 0 :retrieve-data nil)
(odbc:set-cursor-position aq :bookmark :offset 515)
(odbc:set-cursor-position aq :bookmark :offset #(4 2 0 0))
(sql:fetch-rows aq :count 1)
(print-row-status-array aq)
(sql:current-row-status aq)
(sql:current-row-number aq)

(odbc::%sql-fetch (odbc::handle aq))
(odbc::%sql-fetch-scroll (odbc::handle aq) :relative :offset 0 :retrieve-data t)

(odbc::%sql-refresh-record (odbc::handle aq) 0)
(odbc::%sql-position-to (odbc::handle aq) 1)
(odbc::%sql-lock-record (odbc::handle aq) 1 :exclusive)
(odbc::%sql-get-attribute :hstmt (odbc::handle aq) odbc::SQL_ATTR_ROW_NUMBER)
;; row number in entire result set, not in rowset =>  0,  
(odbc::%sql-get-attribute :hstmt (odbc::handle aq) odbc::SQL_ATTR_CONCURRENCY)

(sql:update-records aq :attributes '(text_ [datetime_] [double_] [currency_] [memo_]) ; [ole_])
                       :values `(,(format nil " ~D" (random 100))
                                 ,(get-universal-time)
                                 44.5
                                 1111  ;-922337203685477.6  ; 922337203685477
                                 ,(random-string 500)
                                 ;" -   "
                                 );nil)
                       );:where 525)
(sql:update-records aq :attributes '(text_ [datetime_] [double_]) ;[memo_] [ole_])
                       :values `(,(format nil "Updated by cursor ~D" (random 100))
                                 ,(local-time:current-date)
                                 777.88
                                 ;" -   "
                                 );nil)
                       :where 513)
(sql:update-records aq :av-pairs '((text_ "113-701111")) :where 520)
(sql:update-records aq :attributes 'text_ :values "113-70" :where 520)

(sql:insert-records :into aq :attributes '(text_ [datetime_] [double_])
                       :values `(,(format nil "Added by cursor ~D" (random 100))
                                 ,(local-time:current-timestamp 'local-time:utc-time)
                                 888.999))
                                 
(sql:insert-records :into aq :attributes '(text_ [datetime_] [memo_] [ole_])
                       :values `(,(format nil "Added by cursor ~D" (random 100))
                                 ,(local-time:current-timestamp 'local-time:utc-time)
                                 " -   bulk"
                                 nil))

(sql:delete-records :from aq :where 515)
(odbc::%write-row aq #'(lambda (hstmt) (odbc::%sql-bulk-operations hstmt :add)) 0
                  '(text_ [datetime_] [memo_] [ole_])
                  `(,(format nil "Added by bulk ~D" (random 100))
                    ,(get-universal-time)
                    " -   bulk"
                    nil))
(sql:close-statement aq)
(sql:commit)

(defun set-all-records (cursor attribute value)
  (sql:set-cursor-position cursor :first)
  (loop 
        count (sql:update-records cursor :attributes attribute :values value)
        while (sql:set-cursor-position cursor :next :retrieve-data nil)))
(set-all-records aq [text_] "113")

(setq cur1 (sql-sys:db-open-cursor a [select [long1] [text1] [datetime1] :from [tab1]]
                                 :cursor-type :keyset-driven
                                 :concurrency :optimistic
                                 :rowset-size 10
                                 ))
(time (dotimes (i 100000)
        (sql:insert-records :into cur1 ;:attributes '([long1] [text1] [datetime1])
             :values `(,i
                       ,(concatenate 'string (princ-to-string (random 20)) " - ")
                       ,(+ (get-universal-time) (random 20))))))

(time (loop while (sql:fetch-rows cur1 :count 1)))
(sql:close-statement cur1)

;; SQL_BINARY

(create-table [foo raw-test] '((id integer)
                               (bar (raw 10))
                               (a (varchar 8))))

(insert-records :into [foo raw-test]
                :values (list 1 #*101110010101000011100000000 "raw!"))

;;; Parameters, prepared statements
(ystok.sql.sys:collect-parameters [select [Text_] :from [tab]
                                    :where [< [id] [? :name a]]
                                    :order-by [? :name b]])
(odbc::%sql-func-exists a odbc::SQL_API_SQLEXECUTE)
(sql:execute-command [insert :into [tab] :attributes [text_] :values "abc"]
                     :parameters '([?]) :values '(10))
 :values `(,(apply #'concatenate 'string (make-list 30 :initial-element "123456789 "))))

(setq pa (sql:prepare-statement
    [insert :into [tab] :attributes '([Text_] [Currency_] [DateTime_])
            :values '([? :name text_ :type string]
                      [? :name Currency_ :type :numeric]
                      [? :name DateTime_ :type :timestamp])]))
(sql:execute-command pa 
    :values `("From prepared" 111.12 ,(get-universal-time)))

(setq pa (sql:prepare-statement
    [insert :into [tab] :attributes '([Text_] [Boolean_] [Currency_] [DateTime_]
                                      [Byte_] [Short_] [Long_] [Single_] [Double_])
            :values '([? :name text_ :type string]
                      [? :name boolean_  :type :boolean]
                      [? :name Currency_ :type :numeric]
                      [? :name DateTime_ :type :timestamp]
                      [? :name Byte_	 :type unsigned-byte]
                      [? :name Short_	 :type (integer -32767 32767)]
                      [? :name Long_	 :type integer]
                      [? :name Single_	 :type single-float]
                      [? :name Double_	 :type double-float]) ]
    :database a))
(sql:execute-command pa 
    :values `("From prepared" 0 111/11 ,(get-universal-time) 255 222 3333 4.44 55.5555))

(odbc::%execute-parameterized pa nil
    :values '("  prepared" 1))
(sql:commit :database a)
(sql:rollback :database a)
(sql:close-statement pa)
(sql:cancel-statement pa)

(setq pa (odbc::db-prepare-statement a
   [insert :into [tab] :attributes [Memo_] :values [? :name memo_ :type (string 300)]]))
(sql:execute-command pa 
 :values `(,(apply #'concatenate 'string (make-list 30 :initial-element "123456789 "))))

(odbc::db-execute-parameterized pa 
   [insert :into [tab] :attributes [Memo_] :values [? :name memo_]]
 :values `(,(apply #'concatenate 'string (make-list 30 :initial-element "123456789 "))))

(setq pa (odbc::db-prepare-statement a
   [insert :into [tab] :attributes [Ole_]
           :values [? :name ole_ :type (vector unsigned-byte 300)]]))
(setq v (make-array 300 :element-type '(unsigned-byte 8)))
(dotimes (i (length v)) (setf (aref v i) (mod i 256)))
(odbc::db-execute-parameterized pa nil :values `(,v))

(sql:with-prepared-statement (pa "INSERT INTO tab (Ole_) VALUES (?)"
                        :parameters '([? :name ole_ :type (vector unsigned-byte 300)]))
  (sql:execute-command pa :values `(,v)))

(sql:map-query 'nil
               (lambda (id text) (format t "~&id=~S txt=~S" id text) id)
               [select [id] [text_] :from [tab] :order-by [id :desc] :flatp nil
                       :where [between [id] [? :integer] [? :integer]]]
               :values (list (capi:prompt-for-integer "Enter lower id")
                             (capi:prompt-for-integer "Enter upper id")))

(sql:do-query ((id text &rest rest)
               [select [id] [text_] [long_] :from [tab]
                       :where [<= [id] [? :integer]]]
               :values (list (capi:prompt-for-integer "Enter max id")))
  (format t "~&id=~S text_=~S rest=~S" id text rest))

;;; As doc states, parameter markers don't work inside the select list.
(sql:do-query ((id text &rest rest)
               [select [id] [text_] [long_] [+ [? :integer] 5] :from [tab]	; wrong!
                       :where [<= [id] [? :integer]]]
               :values (list 35 (capi:prompt-for-integer "Enter max id")))
  (format t "~&id=~S text_=~S rest=~S" id text rest))

(sql:with-transaction ()
 (sql:with-prepared-statement (stmt [insert :into [tab]
                                            :attributes '([Text_] [DateTime_] [Long_])
                                            :values '([?] 
                                                      [? :type :universal-time]
                                                      [? :type integer])])
  (dotimes (i 4)
    (sql:execute-command stmt :values (list "" (get-universal-time)
                                            (+ i 200))))))
;; Try paramset-size
(setq pa (sql:prepare-statement
       [insert :into [tab] :av-pairs '(([Text_] [? :name text_ :type string]))]
       :paramset-size 2))

(odbc::db-map-parameters a 'list 
       [insert :into [tab] :av-pairs '(([Text_] [? :name text_ :type string]))]
       '("map-parameters1" "map-parameters2"))

(sql-sys::map-parameters 'list 
       [select [Text_] [Memo_] :from [tab] :where [= [id] [? :type integer]]]
       '((5 15 17))
       :database a)


;; Cronometrics
(sql:with-transaction ()
  (sql:delete-records :from [tab2]))

(time
 (dotimes (i 1000)
   (sql:with-transaction ()
     (sql:insert-records :into [tab2]
                     :attributes '([id] [text2_])
                     :values (list i (format nil "~A" (random 1000)))))))
; LW:
; user time    =      5.015
; system time  =      0.703
; Elapsed time =   0:00:06
; Allocation   = 3887584 bytes standard / 5264677 bytes fixlen
; 0 Page faults
; Allegro:
; cpu time (non-gc) 22,534 msec user, 17,315 msec system
; cpu time (gc)     520 msec user, 0 msec system
; cpu time (total)  23,054 msec user, 17,315 msec system
; real time  416,408 msec (00:06:56.408)
; space allocation:
;  169,716 cons cells, 674,656 other bytes, 0 static bytes

;; Much faster:
(time
  (sql:with-prepared-statement (stmt [insert :into [tab2]
                                             :attributes '([id] [text2_])
                                             :values '([? :type integer]
                                                       [? :type string])])
    (sql:with-transaction ()
      (dotimes (i 1000)
        (sql:execute-command stmt 
                             :values (list i (format nil "~A" (random 1000))))))))
; LW
; user time    =      0.890
; system time  =      0.093
; Elapsed time =   0:00:01
; Allocation   = 647984 bytes standard / 1573990 bytes fixlen
; 0 Page faults

; Allegro: 8.4 seconds used.
; cpu time (non-gc) 16,665 msec user, 14,191 msec system
; cpu time (gc)     490 msec user, 0 msec system
; cpu time (total)  17,155 msec user, 14,191 msec system
; real time  327,922 msec (00:05:27.922)
; space allocation:
;  152,160 cons cells, 371,568 other bytes, 1602 static bytes

;; Even faster:
(time
 (sql:with-transaction ()
   (sql:with-prepared-statement (stmt [insert :into [tab2]
                                              :attributes '([id] [text2_])
                                              :values '([? :type integer]
                                                        [? :type string])])
      (dotimes (i 1000)
        (sql:execute-command stmt 
                             :values (list i (format nil "~A" (random 1000))))))))
;; LW
; user time    =      0.828
; system time  =      0.078
; Elapsed time =   0:00:01
; Allocation   = 651408 bytes standard / 1578852 bytes fixlen
; 0 Page faults


;;; Escape sequences: Timestamp literals
(sql:execute-command "INSERT INTO tab(DateTime_) VALUES({ts'2003-02-13 13:30:31'})")

;;; Escape sequences: Joins
(sql:query [select [tab id] [text_] [table1 id]
                   :from [inner-join [tab] [table1]
                                    :on [= [tab id] [table1 id]]]]
           :database a)
(sql:query [select [tab id] [text_] [table1 id]
                   :from '([tab] [table1])
                   :where [= [tab id] [table1 id]]]
           :database a)

;;; Escape sequences: Procedures
(sql:query "{call outer_join()}")		; ordinary select query without params
(sql:query [funcall [outer-join]])

;; Standard VB functions are available
;; User-defined VB-functions
(sql:execute-command "{call testfun}")		; neither supported as top calls
(sql:query "{call view_calling_testfun}")	; nor from inside views

(setq s [=call [?] [testfun] [id]])
;(sql:defsql-function (:procedure t) "TESTFUN")
(setq s [testfun [id]])
(setq s [funcall [testfun] [id]])
(setq s [=call [?] 'testfun [id]])

(do-query ((a b) "SELECT {fn CONCAT(tab.Text_,tab.Memo_)}, {fn ABS(tab2.Text2_)} 
 FROM {oj tab LEFT OUTER JOIN tab2 ON tab.id = tab2.ID};")
  (format t "~&a=~S:~S b=~S:~S" 
    a (type-of a) b (type-of b)))

(setq s [funcall 'tab-update-text (+ 6 5)])	; action query with parameters
(sql:execute-command [funcall [tab-update-text] (+ 6 5)])
(sql:do-query ((a b) "[funcall [qTabText_ByID(2,2+3)}" :database a) 
  (format t "~&a=~S b=~S" a b))

;;; NZ(v1,v2) = COALESCE(v1,v2)

;;; Sequences

(sql.sys::write-sql-identifier-to-string [my-seq] sql:*default-database* t nil)
(sql:sequence-exists-p [my-seq])
(sql:create-sequence [my-seq])
(sql:drop-sequence [my-seq] :if-does-not-exist :ignore)
(sql:list-sequences)
(sql:sequence-next [my-seq])
(sql:sequence-last [my-seq])
(sql:alter-sequence [my-seq] 3 :min 2)

;;; STREAMS are not implemented in YstokSQL

(do-query ((id (:stream text-stream))
           [select [id] [text] :from [foo bar] :where [< [id] 30]])
          (print id)
          (do ((char (read-char text-stream nil)
                     (read-char text-stream nil))
               (i 0 (1+ i)))
              ((null char))
            (print char)))

(do-query ((id (:stream stream))
           [select [id] [text] :from [foo bar] :where [< [id] 19]])
          (print id)
          (let ((str (make-string 3 :initial-element #\?)))
            (print (peek-char nil stream))
            (print (read-sequence str stream))
            (print str)
            (print (peek-char nil stream))
            (print (peek-char nil stream))
            (print (read-char stream nil))
            (print (read-sequence str stream))
            (print str)
            (print (read-char stream nil))
            ))

(create-table [foo long-test]
              '((id integer :primary-key)
                (text long)))

;; this one might crash in MCL with the DataDirect driver.

(with-prepared-statement (query [insert :into [foo long-test] :values '($ $)])
  (dotimes (i 10)
    (bind-execute-with-stream (query i (:stream stream))
      (dotimes (i 10)
        (write-sequence (random-string 2000) stream)))))

(defun my-execute-command (sql-string)
  (let ((query (odbc::get-free-query sql:*default-database*)))
    (when *trace-sql*
      (format (if (streamp *trace-sql*) *trace-sql* *trace-output*)
              "~&~A;~%" sql-string))
    (with-slots (odbc::hstmt odbc::database) query
      (unless (eq *active-transactions* t)
        (pushnew database *active-transactions*))
      (with-slots (odbc::henv odbc::hdbc) odbc::database
        (unless odbc::hstmt (setf odbc::hstmt (odbc::%new-statement-handle odbc::hdbc))) 
        (unwind-protect 
            (multiple-value-prog1 
                (odbc::%sql-exec-direct sql-string odbc::hstmt odbc::henv odbc::hdbc)
              (format t "~&columns-count=~A rows-count=~A" 
                (odbc::result-columns-count odbc::hstmt)
                (odbc::result-rows-count odbc::hstmt)))
          (db-close-query query))))))

;;; Installer
(sql.sys::list-databases nil :database-type :odbc)
(odbc::db-drivers :odbc)
#| =>
(("SQL Server" ("UsageCount" 2) ("SQLLevel" 1) ("FileUsage" 0) ("DriverODBCVer" "03.50")
        ("ConnectFunctions" "YYY") ("APILevel" 2) ("CPTimeout" 60)) 
 ("Microsoft Access Driver (*.mdb)" ("UsageCount" 3) ("APILevel" 1)
        ("ConnectFunctions" "YYN") ("DriverODBCVer" "02.50") ("FileUsage" 2)
        ("FileExtns" "*.mdb") ("SQLLevel" 0))
 ("Microsoft Text Driver (*.txt; *.csv)" ("UsageCount" 3) ("APILevel" 1)
        ("ConnectFunctions" "YYN") ("DriverODBCVer" "02.50") ("FileUsage" 1)
        ("FileExtns" "*.,*.asc,*.csv,*.tab,*.txt,*.csv") ("SQLLevel" 0))
 ("Microsoft Excel Driver (*.xls)" ("UsageCount" 3) ("APILevel" 1)
       ("ConnectFunctions" "YYN") ("DriverODBCVer" "02.50") ("FileUsage" 1)
       ("FileExtns" "*.xls") ("SQLLevel" 0))
 ("Microsoft dBase Driver (*.dbf)" ("UsageCount" 3) ("APILevel" 1)
       ("ConnectFunctions" "YYN") ("DriverODBCVer" "02.50") ("FileUsage" 1)
       ("FileExtns" "*.dbf,*.ndx,*.mdx") ("SQLLevel" 0))
 ("Microsoft Paradox Driver (*.db )" ("UsageCount" 2) ("APILevel" 1)
       ("ConnectFunctions" "YYN") ("DriverODBCVer" "02.50") ("FileUsage" 1)
       ("FileExtns" "*.db") ("SQLLevel" 0))
 ("Microsoft Visual FoxPro Driver" ("UsageCount" 2) ("APILevel" 0)
       ("ConnectFunctions" "YYN") ("DriverODBCVer" "02.50") ("FileUsage" 1)
       ("FileExtns" "*.dbf,*.cdx,*.idx,*.fpt") ("SQLLevel" 0))
 ("Microsoft ODBC for Oracle" ("UsageCount" 1) ("SQLLevel" 1) ("FileUsage" 0)
       ("DriverODBCVer" "02.50") ("ConnectFunctions" "YYY") ("APILevel" 1)
       ("CpTimeout" 120))
 ("Oracle ODBC Driver" ("APILevel" 1) ("CPTimeout" 60) ("ConnectFunctions" "YYY")
       ("DriverODBCVer" "03.51") ("FileUsage" 0) ("SQLLevel" 1)))
 |#
(odbc::%sql-manage-data-sources t)
(odbc::%sql-config-data-source odbc::ODBC_CONFIG_SYS_DSN "Microsoft Access driver (*.mdb)" "DSN=Repl" :hwnd t)
(odbc::%sql-config-data-source odbc::ODBC_ADD_SYS_DSN "Microsoft Access driver (*.mdb)" "DSN=Repl2" :hwnd t)
(sql:create-database #P"e:/lisp/test/ysqltest.mdb"
                     :database-type 'odbc:access-3.5-database) ;(:version 3)

;;; Object interface

(sql:def-view-class tab1 ()
  ((long1 :initarg :long
          :type integer 
          :db-kind :key)
   (text1 :accessor text1 :initarg :text
    :type (string 30))
   (datetime1 :accessor datetime :initarg :datetime)))

(setq cl (find-class 'tab1))

(setq l (sql:select 'tab1 :flatp t))
(setq l (sql:select 'tab1 :where [= [long1] 4234] :flatp t))

(sql:def-view-class au-tab ()
  ((ID :accessor id :initarg :long
	:type :counter
	:db-kind :key :db-info (:auto-unique-valued t))
   (txt :accessor txt :initarg :txt
	:type (string 30))
   (stamp :accessor stamp :initarg :stamp
	:type lt:local-time)))

(sql:create-view-from-class 'au-tab :database a)

(setq au1 (make-instance 'au-tab :txt "my-text" :stamp (lt:current-timestamp)))
(sql:update-records-from-instance au1 :database a :refresh t)
(setf (txt au1) "my-text1")

(setq au2 (make-instance 'au-tab :txt "my-text2" :stamp (lt:current-timestamp)))
(sql:update-records-from-instance au2 :database a :refresh t)

;;; Caching template

(defvar *aus* (list au1 au2))

(defmethod sql:ensure-db-object ((cursor sql:cursor) (instance au-tab)
                                 &rest args &key slots columns)
 ;;; Providing proper column to db-fetch-item can more complex due to aliasing
  (yl:if-bind (old (find (sql:fetch-item cursor 'id :current t)
                         *aus* :key 'id))
    (values old t)
    (call-next-method)))	;(make-instance 'au-tab :database (sql:database cursor))

#+deprecated
(defmethod sql.sys:db-fetch-into :around ((cursor sql:cursor) (instance au-tab)
                                          &rest args &key current)
 ;;; Providing proper column to db-fetch-item can more complex due to aliasing
  (if (eq instance (clos:class-prototype (class-of instance)))
      (yl:when-bind (id (sql.sys:db-fetch-item cursor
                                               'id
                                               :current current))
        (let* ((old (find id *aus* :key 'id))
               (value (apply #'call-next-method cursor (or old instance) :current t
                             (yl:remove-properties args '(:current)))))
          (when old
            (sql:instance-refreshed old))
          value))
      (call-next-method)))

(sql:select 'au-tab :refresh nil)
(sql:select [*] :from [au-tab])

;;; Security

(sql:drop-table [ys_roles_contain] :database a :if-does-not-exist :ignore)
(sql::drop-view-from-class 'sql:role :database a)
(sql::create-role-tables a)
(odbc::db-describe-columns a [ys_roles])

(sql:select [*] :from [ys_roles])
(sql:insert-records :into [ys_roles]
                :columns `(,[id] ,[role-name] ,[explicit-allow] ,[explicit-deny])
                :values (list 2 "Test-role" #*1011 #*0111111100111))
(setq allow (sql:select [explicit-allow] :from [ys_roles] :where [= [id] 2]
                        :flatp t))
(setq allow (sql:select [explicit-allow :type (bit-vector 32)] :from [ys_roles] :where [= [id] 2]
                        :flatp t))
(setq deny (sql:select [explicit-deny :type (bit-vector 32)] :from [ys_roles] :where [= [id] 2]
                        :flatp t))
(setq r (first (sql:select 'sql:role :where [= [slot-value 'sql:role 'sql::id] 2]
                    :flatp t)))

#||

(sql.sys::%print-tuples '(("1" "22" "333")
                          ("11" nil "3333")
                          (1.1 2.22   3.333))
                        :titles '("col_1" "col_2" "col_3"))

(sql.sys::float-to-sql-string 2.3s34)

||#
