;;; Test sqlite3odbc.dll (0.70) http://www.ch-werner.de/sqliteodbc/
;;; against SQLite3 (3.3.4) on Windows 2000
;;;
;;; Unsupported statement attributes (=>SQL_SUCCESS_WITH_INFO 01S02: option value changed)
;;;   SQL_ATTR_CONCURRENCY: seems only supported SQL_CONCUR_LOCK, the default value.
;;; 
;;; 

(sql:enable-sql-reader-syntax)
(sql:disable-sql-reader-syntax)
#+ys-product (setq ys::*compile-for-lazyload* t)
(ffc:initialize-ffc-locale :latin-1) ;(setf ffc:*foreign-code-page* :latin-1 ))
  #-(and Unicode (not (or lispworks4.2 lispworks4.3)))
  (let* ((length (- end start))
         (str (make-string length :element-type (ef:external-format-type ffc:*foreign-ef*))))

(sql:initialize-database-type :database-type :odbc)
(sql:data-sources :odbc)

(connect nil)
;(setq pg (sql:connect '("pgtest_ANSI" :user "postgres" :password "pg10") :autocommit t))
(setq L (sql:connect "TestSQLite")) ; :autocommit t))
(setq L (sql:connect #P"e:/lisp/test/ysqltest.db" :database-type :sqlite3))
(setq L (sql:connect #P"e:/lisp/test/ysqltest.db" :database-type :sqlite3  :unicode t))

(setq L (sql:connect nil :driver-av-pairs `((:driver ,*sqlite3-driver*)
                                            (:database #P"e:/lisp/test/ysqltest.db"))))
(setq L sql:*default-database*)
(sql:connected-databases)
(sql:disconnect :database L)
(type-of L)

(odbc::%sql-free-handle :hdbc (odbc::hdbc db))
(odbc::%sql-free-handle :henv (odbc::henv db))
(setf (odbc::henv db) nil)

;;; Environment attributes
(odbc::%sql-get-attribute :henv (odbc::henv pg) odbc::SQL_ATTR_CONNECTION_POOLING)
(odbc::%sql-get-attribute :henv (odbc::henv pg) odbc::SQL_ATTR_ODBC_VERSION)
;(odbc::%sql-get-attribute :henv (odbc::henv db) odbc::SQL_ATTR_OUTPUT_NTS)

;;; Connection attributes
(odbc::%sql-get-attribute :hdbc ffc:+sql-null-handle+ odbc::SQL_ATTR_TRACEFILE)
(odbc::%sql-get-attribute :hdbc (odbc::hdbc pg) odbc::SQL_ATTR_CURRENT_CATALOG)
(odbc::%sql-get-attribute :hdbc (odbc::hdbc pg) odbc::SQL_ATTR_QUIET_MODE)
(odbc::%sql-get-attribute :hdbc (odbc::hdbc pg) odbc::SQL_ATTR_ACCESS_MODE) ;SQLUINTEGER
(odbc::%sql-get-attribute :hdbc (odbc::hdbc pg) odbc::SQL_ATTR_TXN_ISOLATION)
(odbc::%sql-get-attribute :hdbc (odbc::handle L) odbc::SQL_ATTR_AUTOCOMMIT) ;=> 1
(odbc::%sql-set-attribute :hdbc (odbc::handle L) odbc::SQL_ATTR_AUTOCOMMIT odbc::SQL_AUTOCOMMIT_ON)
(odbc::%sql-get-attribute :hdbc (odbc::handle pg) odbc::SQL_ATTR_CONNECTION_TIMEOUT)
;=> 0 (Not impelmenented)
(odbc::%sql-get-attribute :hdbc (odbc::handle pg) odbc::SQL_ATTR_LOGIN_TIMEOUT)
;=> 0 (Not impelmenented)

;;; DB info

(odbc::db-get-info sql:*default-database* odbc::SQL_SQL_CONFORMANCE) ;=> unsupported

(odbc::db-get-info sql:*default-database* odbc::SQL_SERVER_NAME);=> "D:\\path\\name.db"
(odbc::db-get-info sql:*default-database* odbc::SQL_DBMS_NAME)	;=> "SQLite"
(odbc::%get-info-result-type odbc::SQL_DBMS_NAME)
(odbc::db-get-info sql:*default-database* odbc::SQL_DBMS_VER)   ;=> "3.3.7"

(odbc::%sql-get-info (odbc::hdbc sql:*default-database*) odbc::SQL_ODBC_VER) ;=> HANGS?!
; Win2K => "03.52.0000" 

(odbc:db-get-info sql:*default-database* odbc::SQL_DRIVER_ODBC_VER) ; "03.00"
(odbc:db-get-info sql:*default-database* odbc::SQL_TXN_CAPABLE) ;=> 2 (odbc::SQL_TC_ALL)
(odbc:db-get-info sql:*default-database* odbc::SQL_TXN_ISOLATION_OPTION)
;=> 1 = SQL_TXN_READ_UNCOMMITTED
(odbc:db-get-info sql:*default-database* odbc::SQL_DEFAULT_TXN_ISOLATION)
; => 1 = SQL_TXN_READ_UNCOMMITTED
(odbc:db-get-info sql:*default-database* odbc::SQL_MULTIPLE_ACTIVE_TXN) ;=> T

(odbc:db-get-info sql:*default-database* odbc::SQL_MAX_DRIVER_CONNECTIONS)	;=> 0
(odbc:db-get-info sql:*default-database* odbc::SQL_MAX_CONCURRENT_ACTIVITIES)
;=> 0 - no specified limit or the limit is unknown
(odbc:db-get-info sql:*default-database* odbc::SQL_MAX_ASYNC_CONCURRENT_STATEMENTS)
;=> Not supported

(odbc::db-get-info sql:*default-database* odbc::SQL_GETDATA_EXTENSIONS)
;=> 11 = SQL_GD_ANY_COLUMN + SQL_GD_ANY_ORDER + SQL_GD_BOUND
(odbc::db-get-info sql:*default-database* odbc::SQL_CATALOG_NAME)	;=> nil
(odbc::db-get-info sql:*default-database* odbc::SQL_CATALOG_USAGE)	;=> 0
(odbc::db-get-info sql:*default-database* odbc::SQL_CATALOG_TERM) 	;=> ""
(odbc::db-get-info sql:*default-database* odbc::SQL_CATALOG_LOCATION)	;=> 1 SQL_CL_START
(odbc::db-get-info sql:*default-database* odbc::SQL_CATALOG_NAME_SEPARATOR) ; => "."
(odbc::db-get-info sql:*default-database* odbc::SQL_MAX_CATALOG_NAME_LEN) ; => 255

(odbc::db-get-info sql:*default-database* odbc::SQL_SCHEMA_USAGE)	;=> 0
(odbc::db-get-info sql:*default-database* odbc::SQL_SCHEMA_TERM)	;=> "owner"
(odbc::db-get-info sql:*default-database* odbc::SQL_MAX_SCHEMA_NAME_LEN);=> 255

(odbc::db-get-info sql:*default-database* odbc::SQL_IDENTIFIER_QUOTE_CHAR) ; => "\""
(odbc::db-get-info sql:*default-database* odbc::SQL_SPECIAL_CHARACTERS)    ;=> ""
(odbc::db-get-info sql:*default-database* odbc::SQL_MAX_TABLE_NAME_LEN)	   ; => 255

(odbc::db-get-info sql:*default-database* odbc::SQL_PARAM_ARRAY_ROW_COUNTS);=> 0
(odbc::db-get-info sql:*default-database* odbc::SQL_PARAM_ARRAY_SELECTS)   ;=> unsupported
(odbc::db-get-info sql:*default-database* odbc::SQL_PROCEDURES)		   ;=> nil
(odbc::db-get-info sql:*default-database* odbc::SQL_OJ_CAPABILITIES)	   ;=> 0

(odbc::%sql-func-exists sql:*default-database* odbc::SQL_API_SQLBULKOPERATIONS) ;=> nil

;;; Scalar functions are not supported
(odbc::db-get-info sql:*default-database* odbc::SQL_NUMERIC_FUNCTIONS)	;=> 0
(odbc::db-get-info sql:*default-database* odbc::SQL_STRING_FUNCTIONS)	;=> 0
(odbc::db-get-info sql:*default-database* odbc::SQL_CONVERT_FUNCTIONS)	;=> 0

(odbc::db-get-info sql:*default-database* odbc::SQL_ROW_UPDATES)               ;=> nil
(odbc::db-get-info sql:*default-database* odbc::SQL_BOOKMARK_PERSISTENCE)
;=> 64 = SQL_BP_SCROLL(#x00000040)
(odbc::db-get-info sql:*default-database* odbc::SQL_SCROLL_OPTIONS)
;=> 17 = SQL_SO_FORWARD_ONLY + SQL_SO_STATIC
(odbc::db-get-info sql:*default-database* odbc::SQL_CURSOR_COMMIT_BEHAVIOR)
;=> 2 SQL_CB_PRESERVE
(odbc::db-get-info sql:*default-database* odbc::SQL_CURSOR_ROLLBACK_BEHAVIOR)
;=> 2 SQL_CB_PRESERVE
(odbc::db-get-info sql:*default-database* odbc::SQL_SCROLL_CONCURRENCY) ;=> 2
(odbc::db-get-info sql:*default-database* odbc::SQL_STATIC_SENSITIVITY)
;=> 0 Indicates whether a cursor is sensitive to changes made by another cursor.

(odbc::db-get-info sql:*default-database* odbc::SQL_DYNAMIC_CURSOR_ATTRIBUTES1) ; => 0
(odbc::db-get-info sql:*default-database* odbc::SQL_DYNAMIC_CURSOR_ATTRIBUTES2) ; => 0
(odbc::db-get-info sql:*default-database* odbc::SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES1)
;=> SQL_CA1_NEXT (1)
(odbc::db-get-info sql:*default-database* odbc::SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES2)
;=> 1 SQL_CA2_READ_ONLY_CONCURRENCY
(odbc::db-get-info sql:*default-database* odbc::SQL_KEYSET_CURSOR_ATTRIBUTES1)
;=> 990799   updateable cursors!
;=> 4687 = #x124F (SQL_CA1_...)
;	= NEXT + ABSOLUTE + RELATIVE
;	+ LOCK_NO_CHANGE + LOCK_UNLOCK
;	+ POS_POSITION + POS_UPDATE + POS_DELETE + POS_REFRESH
;	+ <SQL_ADD is permited in SQLSetPos>
;	+ POSITIONED_UPDATE + POSITIONED_DELETE + SELECT_FOR_UPDATE
(odbc::db-get-info sql:*default-database* odbc::SQL_KEYSET_CURSOR_ATTRIBUTES2) ;=> 0
(odbc::db-get-info sql:*default-database* odbc::SQL_STATIC_CURSOR_ATTRIBUTES1) ;=> 15
(odbc::db-get-info sql:*default-database* odbc::SQL_STATIC_CURSOR_ATTRIBUTES2) ;=> 3
(odbc::db-get-info sql:*default-database* odbc::SQL_POS_OPERATIONS) ;=>0(deprecated in 3.0)

(format nil "#x~x" 130639)

(odbc::db-get-info sql:*default-database* odbc::SQL_NEED_LONG_DATA_LEN)	;=> #\Y

;;; Asynchronous
(odbc::%sql-get-info (odbc::handle L) 10021) ;odbc::SQL_ASYNC_MODE)
;=> 0 = SQL_AM_NONE  Asynchronous mode is not supported
(odbc::%sql-get-attribute :hdbc (odbc::handle L) odbc::SQL_ATTR_ASYNC_ENABLE) ;=> 0 = OFF
(odbc::%sql-set-attribute :hdbc (odbc::handle L) odbc::SQL_ATTR_ASYNC_ENABLE 1)
;=> option value changed

;;; CATALOG Functions 

(odbc::db-describe-type L odbc::SQL_INTEGER) ;=> 
(odbc::db-describe-type L 0) ;=>
(("wtext" -10 65536 "'" "'" "length" 1 0 3 NIL 0 0 "wtext" NIL NIL)
 ("longwvarchar" -10 65536 "'" "'" "length" 1 0 3 NIL 0 0 "longwvarchar" NIL NIL)
 ("wvarchar" -9 255 "'" "'" "length" 1 0 3 NIL 0 0 "wvarchar" NIL NIL)
 ("wchar" -8 255 "'" "'" "length" 1 0 3 NIL 0 0 "wchar" NIL NIL)
 ("bit" -7 1 NIL NIL NIL 1 0 3 NIL 0 0 "bit" NIL NIL)
 ("tinyint" -6 3 NIL NIL NIL 1 0 3 0 0 0 "tinyint" NIL NIL)
 ("bigint" -5 19 NIL NIL NIL 1 0 3 0 0 0 "bigint" NIL NIL)
 ("longvarbinary" -4 65536 NIL NIL NIL 1 0 3 NIL 0 0 "longvarbinary" NIL NIL)
 ("varbinary" -3 255 NIL NIL NIL 1 0 3 NIL 0 0 "varbinary" NIL NIL)
 ("text" -1 65536 "'" "'" "length" 1 0 3 NIL 0 0 "text" NIL NIL)
 ("longvarchar" -1 65536 "'" "'" "length" 1 0 3 NIL 0 0 "longvarchar" NIL NIL)
 ("char" 1 255 "'" "'" "length" 1 0 3 NIL 0 0 "char" NIL NIL)
 ("integer" 4 7 NIL NIL NIL 1 0 3 0 0 0 "integer" NIL NIL)
 ("smallint" 5 5 NIL NIL NIL 1 0 3 0 0 0 "smallint" NIL NIL)
 ("float" 6 7 NIL NIL NIL 1 0 3 0 0 0 "float" NIL NIL)
 ("double" 8 15 NIL NIL NIL 1 0 3 0 0 0 "double" NIL NIL)
 ("numeric" 8 15 NIL NIL NIL 1 0 3 0 0 0 "numeric" NIL NIL)
 ("varchar" 12 255 "'" "'" "length" 1 0 3 NIL 0 0 "varchar" NIL NIL)
 ("date" 91 10 "'" "'" NIL 1 0 3 NIL 0 0 "date" NIL NIL)
 ("time" 92 8 "'" "'" NIL 1 0 3 NIL 0 0 "time" NIL NIL)
 ("timestamp" 93 32 "'" "'" NIL 1 0 3 NIL 0 0 "timestamp" NIL NIL)) 
("TYPE_NAME" "DATA_TYPE" "PRECISION" "LITERAL_PREFIX" "LITERAL_SUFFIX" "CREATE_PARAMS" "NULLABLE" "CASE_SENSITIVE" "SEARCHABLE" "UNSIGNED_ATTRIBUTE" "MONEY" "AUTO_INCREMENT" "LOCAL_TYPE_NAME" "MINIMUM_SCALE" "MAXIMUM_SCALE") 

(sql:list-tables :database L) ; = :schema :all)
;=> ("CLASS_TABLE" "USERS_TABLE" "_CLSQL_SEQ_USERS_SEQUENCE" ...)
(sql:list-tables :database L :schema "public")

(odbc::db-describe-tables L "CLASS_TABLE")
 ;=1> (("" "" "CLASS_TABLE" "TABLE" NIL)) 
 ;=2> ("TABLE_QUALIFIER" "TABLE_OWNER" "TABLE_NAME" "TABLE_TYPE" "REMARKS") 

(odbc::db-describe-tables L "employee")

(sql:list-attributes [class-table])
;=> ("CLASSID" "CLASSNAME" "COUNTER" "SUPERCLASS" "CLASSDEF")
(odbc::db-describe-columns L "CLASS_TABLE")
(odbc::db-describe-columns L "CLASS_TABLE" :column "%")

(odbc::db-describe-columns L [employee])
(odbc::db-describe-columns L [employee] :column "birthday")
(sql:list-attributes [employee] :schema :all)
(sql:attribute-type [first-name] [employee])	;=> (:VARCHAR 30), 30, 10, 1
(sql:attribute-type [height] [employee]) 	;=> :FLOAT, 53, 10, 1

(odbc::db-describe-columns L "BIG")

(odbc::db-describe-special-columns L "mytab")  "CLASS_TABLE") ;=>
;=1>((2 "CLASSID" 12 "NUMBER" 0 255 0 1 1)) 
;=2>("SCOPE" "COLUMN_NAME" "DATA_TYPE" "TYPE_NAME" "PRECISION" "LENGTH" "DECIMAL_DIGITS" "PSEUDO_COLUMN" "NULLABLE") 

(odbc::db-describe-primary-keys L "mytab" )"CLASS_TABLE")
;=1>(("" "" "CLASS_TABLE" "CLASSID" 1 "sqlite_autoindex_CLASS_TABLE_1")) 
;=2>("TABLE_QUALIFIER" "TABLE_OWNER" "TABLE_NAME" "COLUMN_NAME" "KEY_SEQ" "PK_NAME") 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; DDL ;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun random-string (size)
  (let ((str (make-string size :element-type 'base-character)))
    (dotimes (i size)
      (setf (char str i) (code-char (+ 97 (random 26)))))
    str))
(defun increasing-vector (size)
  (let ((v (make-array size :element-type '(unsigned-byte 8))))
    (loop for i upfrom 0 below size
          and j = 0 then (if (= j 199) 0 (1+ j))
          do (setf (aref v i) (if (zerop (mod i 100)) (truncate i 100) (mod i 100))))
    v))

(setq v (make-array 300 :element-type '(unsigned-byte 8)))
(dotimes (i (length v)) (setf (aref v i) (mod i 256)))

(sql:drop-table [mytab] :database L)
(sql:create-table [mytab]
  `(([id] integer :primary-key)
    ([char_] (:char 32) ;(string 32)
     :default "Mmyyytable default")
                     ; :check ,[and [> [id] 0] [>= [text-moo] "m%"]]))
    ; ("varchar" 12 255 "'" "'" "length" 1 0 3 NIL 0 0 "varchar" NIL NIL)
    ([int_] integer)
    ([smallint_] (integer -1000 1000))

    ([tinyint_] :tinyint)
    ([bigint_] :bigint)
    ([date_] date)
    ;("time" 92 8 "'" "'" NIL 1 0 3 NIL 0 0 "time" NIL NIL)
    ;("timestamp" 93 32 "'" "'" NIL 1 0 3 NIL 0 0 "timestamp" NIL NIL)) 
    ([real_] single-float)
    ([double_] double-float)
    ;("numeric" 8 15 NIL NIL NIL 1 0 3 0 0 0 "numeric" NIL NIL)
    ([clob_] :longvarchar) ;:text)
    ([bit_]  bit)
    ([bin_]  :varbinary)
    ([blob_] :longvarbinary)
    ;([raw_] (:bit 64)) ;([raw_] (bit-vector 64))
   )
  :constraints
   '(;([table1-id] :foreign-key ([tab-id]) :references [tab] [id])
    ; (:check ,[> [tab-id] 5]) ; MSA not supported
   )
   :database L
)
(odbc::db-describe-columns L "mytab") ;=>
(("" "" "mytab" "ID" 4 "INTEGER" 9 10 10 0 1 NIL "NULL" 4 NIL 16384 1 "YES")
 ("" "" "mytab" "CHAR_" 12 "CHAR(32)" 32 32 10 0 1 NIL "Mmyyytable default" 12 NIL 16384 2 "YES")
 ("" "" "mytab" "INT_" 4 "INTEGER" 9 10 10 0 1 NIL "NULL" 4 NIL 16384 3 "YES")
 ("" "" "mytab" "SMALLINT_" 5 "SMALLINT" 5 6 10 0 1 NIL "NULL" 5 NIL 16384 4 "YES")
 ("" "" "mytab" "TINYINT_" -6 "TINYINT" 3 4 10 0 1 NIL "NULL" -6 NIL 16384 5 "YES")
 ("" "" "mytab" "BIGINT_" -5 "BIGINT" 19 20 10 0 1 NIL "NULL" -5 NIL 16384 6 "YES")
 ("" "" "mytab" "DATE_" 91 "DATE" 0 10 10 0 1 NIL "NULL" 91 NIL 16384 7 "YES")
 ("" "" "mytab" "REAL_" 8 "REAL" 53 54 10 0 1 NIL "NULL" 8 NIL 16384 8 "YES")
 ("" "" "mytab" "DOUBLE_" 8 "DOUBLE PRECISION" 53 54 10 0 1 NIL "NULL" 8 NIL 16384 9 "YES")
 ("" "" "mytab" "CLOB_" 12 "LONGVARCHAR" 0 255 10 0 1 NIL "NULL" 12 NIL 16384 10 "YES")
 ("" "" "mytab" "BIT_" -7 "BIT" 0 0 10 0 1 NIL "NULL" -7 NIL 16384 11 "YES")
 ("" "" "mytab" "BIN_" -3 "VARBINARY" 0 255 10 0 1 NIL "NULL" -3 NIL 16384 11 "YES")
 ("" "" "mytab" "BLOB_" -4 "LONGVARBINARY" 0 65536 10 0 1 NIL "NULL" -4 NIL 16384 12 "YES")) 
("TABLE_QUALIFIER" "TABLE_OWNER" "TABLE_NAME" "COLUMN_NAME" "DATA_TYPE" "TYPE_NAME" "PRECISION" "LENGTH" "RADIX" "SCALE" "NULLABLE" "REMARKS" "COLUMN_DEF" "SQL_DATA_TYPE" "SQL_DATETIME_SUB" "CHAR_OCTET_LENGTH" "ORDINAL_POSITION" "IS_NULLABLE") 

(odbc::db-describe-columns L "EMPLOYEE" :column "\"EMPLID\"") ;=>

;; Sequences
(sql:execute-command "CREATE SEQUENCE MY_SEQ;")
(sql:commit)
(sql:select [my-seq nextval] [my-seq currval] :from 'dual)
(sql:execute-command "DROP SEQUENCE MY_SEQ;")

;;; DML
(defvar id 1 )

(sql:insert-records :into [mytab]
  :attributes '([id] [char_] [int_] [smallint_] [tinyint_] [bigint_]
                [date_] [real_] [double_] [bit_]
                [clob_])
               ;[raw_] [blob_])
 :values `(,(incf id) "  from Lisp" 
           105 9876 -128  ; signed1
           ,(- (+ #xFFFFFFFF id)) ;-18446744078004518656
           @2006-04-25 43.21 123.456789 1 ;:true does not work
           "CLOB 1 from Lisp by insert"))
 ;:values `(1 105 "  " 9876 "10.03.2003" 43.21 123.456789
 ;          "23 Longtext   by insert"  "CLOB   by insert"))
           ;"\\001" ; #*0011001000110011  ; ,v))

(sql:insert-records :into [mytab]
  :attributes '([id] [empno] [char_] [smallint_])
  :values `(130 104 "  " [my-seq nextval]))

(sql:insert-records :into [tab2]
                    :attributes '([id] [text2_])
                    :values (list 10 "  "))
(sql:insert-records :into [tab2]
                    :av-pairs '(([id] 11) ([text2_] "  ")))
(sql:insert-records :into [tab2]
                    :attributes '([id] [text2_])
                    :query [SELECT ["tt" ID] ["tt" TEXT_]
                                   :FROM [tab "tt"]
                                   :where [< ["tt" ID] 15]])
(sql:insert-records :into [tab2] :attributes [id] :values 40)
(setq n 14)
(sql:delete-records :from [mytab] :where [< [ID] n])
(sql:update-records [tab2] :attributes '([text2_]) :values " "
                           :where [>= [ID] 5])
(sql:update-records [tab2] :attributes [text2_] :values " "
                           :where [= [ID] 5])

;; SQL_BINARY

(create-table
 [foo raw-test]
 '((id integer)
   (bar (raw 10))
   (a (varchar 8))))

(insert-records :into [foo raw-test]
                :values (list 1 #*101110010101000011100000000 "raw!"))

;;; Queries
; (%sql-set-attribute :hstmt handle SQL_ATTR_MAX_ROWS (or limit 0)) - UNSUPPORTED

(sql:query "SELECT * FROM mytab;")
(sql:select [*] :from [mytab] :order-by [char_])
(sql:select [*] :from [mytab] :where [like [char_] "%%"])
(sql:select [*] :from [company])


(setq s (sql:select [ROWID] [mytab *] :from [mytab])) ; :where [= [ENAME] ""])

(sql:query "SELECT * FROM CLASS_TABLE;")
(sql:query "SELECT * FROM _CLSQL_SEQ_USERS_SEQUENCE")
;=> ((1 1 1 "t")),("last_value" "increment_by" "min_value" "is_called")
(sql:select [*] :from [users-table])

(odbc:db-describe-columns L "TABLE_3106") ;=>
(("" "" "TABLE_3106" "ID" 12 "NUMBER" 0 255 10 0 0 NIL "NULL" 12 NIL 16384 1 "NO")
 ("" "" "TABLE_3106" "STATUS" 4 "INT" 9 10 10 0 1 NIL "NULL" 4 NIL 16384 2 "YES")
("" "" "TABLE_3106" "SLOT0" 12 "VARCHAR(20)" 20 20 10 0 1 NIL "NULL" 12 NIL 16384 3 "YES")
("" "" "TABLE_3106" "SLOT1" -1 "VARCHAR(65536)" 65536 65536 10 0 1 NIL "NULL" -1 NIL 16384 4 "YES")
("" "" "TABLE_3106" "SLOT2" -7 "BOOL" 0 0 10 0 1 NIL "NULL" -7 NIL 16384 5 "YES")
("" "" "TABLE_3106" "SLOT3" -1 "VARCHAR(65536)" 65536 65536 10 0 1 NIL "NULL" -1 NIL 16384 6 "YES")
("" "" "TABLE_3106" "SLOT4" 12 "VARCHAR(30)" 30 30 10 0 1 NIL "NULL" 12 NIL 16384 7 "YES")
("" "" "TABLE_3106" "SLOT5" 12 "VARCHAR(50)" 50 50 10 0 1 NIL "NULL" 12 NIL 16384 8 "YES")
) 
("TABLE_QUALIFIER" "TABLE_OWNER" "TABLE_NAME" "COLUMN_NAME" "DATA_TYPE" "TYPE_NAME" "PRECISION" "LENGTH" "RADIX" "SCALE" "NULLABLE" "REMARKS" "COLUMN_DEF" "SQL_DATA_TYPE" "SQL_DATETIME_SUB" "CHAR_OCTET_LENGTH" "ORDINAL_POSITION" "IS_NULLABLE") 

(defmethod odbc::db-sql-to-c-type ((database odbc::sqlite-odbc-database)
                                   (sql-type (eql #.odbc::SQL_BIT))
                                   column-size decimal-digits)
  odbc::SQL_C_CHAR)

(sql:select [*] :from "TABLE_3106")


(sql:select [city] [temp-lo] :from [weather])

(sql:query [select [id] :as [i] :from [tab] :group-by [id]
                   :order-by '([id] :desc [Text_])])
(sql:query "SELECT ID FROM tab" :flatp t)

(sql:select [char_] :from [mytab] :flatp t :distinct t)
(sql:map-query 'nil (lambda (id text) (format t "~&id=~S txt=~S" id text)
                                       id)
               [select [id] [text_] :from [tab] :order-by [id :desc] :flatp nil])

(time (sql:query "SELECT Text_,Long_,Single_,Memo_ FROM tab" :database a))
(sql:query "SELECT TOP 5 ID,Boolean_,DateTime_,Byte_,Short_,Double_ FROM tab" :database a)

(sql:do-query ((a b &rest rest)
           [select [*] :from [tab2]])
          (print (list a b)))

(sql:select [employee last-name] [company name]
            :from [inner-join [employee] [company]
                              :on [= [employee ecompanyid] [company companyid]]]
            :order-by [last-name])

;; SQLite cannot stand the parentheses around join
(sql:query "SELECT EMPLOYEE.LAST_NAME,COMPANY.NAME FROM COMPANY INNER JOIN (EMPLOYEE INNER JOIN ea_join ON EMPLOYEE.EMPLID=ea_join.AEMPLID) ON COMPANY.COMPANYID=EMPLOYEE.ECOMPANYID ORDER BY LAST_NAME")

;;; Parameters, prepared statements and procedures

(setq pl (sql:prepare-statement 
    [insert :into [mytab]
            :columns '([id] [bigint_])
            :values  '([? :name id	:type integer]
                       [? :name bigint_ :type :bigint]
                      )]
    :database L))
(sql:execute-command pl
 :values `(,(incf id) ,(- (+ #xFFFFFFFF id))))


(ystok.sql.sys:collect-parameters [select [Text_] :from [tab]
                                    :where [< [id] [? :name a]]
                                    :order-by [? :name b]])
(sql:query "SELECT * FROM mytab WHERE id >= 30 ORDER BY id")
(defvar id 35)
(setq po (sql:prepare-statement 
    [insert :into [mytab]
            :attributes '([id] [empno] [char_] [smallint_] [date_] [double_] ;[real_] 
                          [raw_] [longtext_] [clob_] [blob_])
            :values  '([? :name id	:type integer]
                       [? :name empno	:type integer]
                       [? :name char_]
                       [? :name smallint_ :type (integer -1000 1000)]
                       [? :name date_	:type :universal-time]
                       [? :name double_ :type double-float]
                       ;[? :name real_	:type single-float] ; works incorrectly in LW
                       [? :name raw_	:type bit-vector]
                       [? :name longtext_ :type (string 5000)]
                       [? :name clob_]
                       [? :name blob_ :type (vector unsigned-byte 300)])]
    :database o))
(sql:execute-command po
 :values `(,(incf id) 105 "  prepared" 987 ,(get-universal-time) 123.456789 ;3.5
           #*0011001000110011  "23 Longtext  prepared"  nil ,v))
           ;#*0011001000110011 "23 Longtext  prepared"  "CLOB  " ,v))

(odbc::db-execute-parameterized po 
    [insert :into [mytab]
            :attributes '([id] [empno] [char_] [smallint_] [date_] [real_] [double_]
                          [raw_] [longtext_] [clob_] [blob_])
            :values  '([? :name id	:type integer]
                       [? :name empno	:type integer]
                       [? :name char_]
                       [? :name smallint_ :type (integer -1000 1000)]
                       [? :name date_	:type :universal-time]
                       [? :name real_	:type single-float] ; works incorrectly in LW
                       [? :name double_ :type double-float]
                       [? :name raw_	:type bit-vector]
                       [? :name longtext_ :type (string 5000)]
                       [? :name clob_]
                       [? :name blob_])]
 :values `(,(incf id) 105 "  prepared" 987 ,(get-universal-time) 33.21 123.456789
           #*0011001000110011  "23 Longtext  prepared" nil ,v))

(sql:commit :database o)
(sql:close-statement pl :drop-p t)
(sql:cancel-statement po)
(sql:rollback :database o)

(sql:do-query ((id raw_ blob_)
               [select [id] [raw_] [blob_] :from [mytab] :where [>= [id] (1- id)]])
    (format t "~&id=~S raw_(~S)=~S~%blob_(~S)=~S"
            id (type-of raw_) raw_ (type-of blob_) blob_))

(setq pqo (odbc::db-prepare-statement o
    [select [id] [char_] :from [mytab] :where [= [id] [? :name id :type integer]]]))
(odbc::%execute-parameterized pqo nil nil '(24))
(sql:fetch-rows pqo)
(sql:close-statement pqo :drop-p nil)

(setq po (sql:prepare-statement 
          [insert :into [mytab] :attributes '([id] [char_])
                  :values  '([? :name id :type integer] [? :name char_])]
          :database o :paramset-size 2))
(sql:execute-command po :values '((44 45) ("text 44" "text 45")))

(setq po (sql:prepare-statement 
          [insert :into [mytab] :attributes '([id] [longtext_] [blob_])
                  :values  '([? :name id :type integer]
                             [? :type (string 5000)]
                             [? :name blob_ :type (vector unsigned-byte 6000)])]
          :database o :paramset-size 2))
(setq s1 (random-string 200) s2 (random-string 300)
      v1 (increasing-vector 300) v2 (increasing-vector 400))
(sql:execute-command po :values (list '(54 55) (list s1 s2) (list v1 v2)))

(sql:select [id] [longtext_] [blob_] [char_]  :from [mytab] :where [>= [id] 54]
            :database o)



(with-prepared-statement (query [insert :into [tab] :attributes '([id] [Text_]:values '($ $ $)])
  (bind-execute query "" 1001 (get-universal-time)))

(time
 (dotimes (i 1000)
   (with-transaction
     (insert-records :into [Table1]
                     :values (list (format nil "~A" (random 20)) i)))))
; cpu time (non-gc) 22,534 msec user, 17,315 msec system
; cpu time (gc)     520 msec user, 0 msec system
; cpu time (total)  23,054 msec user, 17,315 msec system
; real time  416,408 msec (00:06:56.408)
; space allocation:
;  169,716 cons cells, 674,656 other bytes, 0 static bytes

;; much faster:
(time
 (progn
  (with-prepared-statement (query [insert :into [Table1] :values '($ $ $)])
    (dotimes (i 1000)
      (with-transaction ()
        (bind-execute query (format nil "~A - " (random 20)) 
                      i
                      (+ (get-universal-time) (random 10000))))))))
;8.4 seconds used.
;Standard Allocation 348048 bytes.
;Fixlen Allocation 89595 bytes.
; cpu time (non-gc) 16,665 msec user, 14,191 msec system
; cpu time (gc)     490 msec user, 0 msec system
; cpu time (total)  17,155 msec user, 14,191 msec system
; real time  327,922 msec (00:05:27.922)
; space allocation:
;  152,160 cons cells, 371,568 other bytes, 1602 static bytes

(time (do-query ((txt l d) "SELECT TOP 1000 text1,long1,datetime1 FROM table1")
  (let ((s (format nil "~&txt=~S l=~S d=~S" 
                   txt l (and d (format-time d))))))))
;76.7 seconds used.
;Standard Allocation 702080 bytes.
;Fixlen Allocation 861531 bytes.

;;; Escape sequences, outer joins
(sql:query [select [emp empno] [ename] [mytab empno] [char_]
                   :from [right-join [emp] [mytab]
                                    :on [= [emp empno] [mytab empno]]]]
           :database o)

(sql:query [select [emp empno] [ename] [mytab empno] [char_]
                   :from [inner-join [emp] [mytab]
                                    :on [= [emp empno] [mytab empno]]]]
           :database o)
(sql:query [select [emp empno] [ename] [mytab empno] [char_]
                   :from '([emp] [mytab])
                   :where [= [emp empno] [mytab empno]]]
           :database o)

(sql:execute-command "INSERT INTO tab(DateTime_) VALUES({ts'2003-02-13 13:30:31'})")

(do-query ((a b) "SELECT Text_,Text2_ FROM outer_join;")
  (format t "~&a=~S:~S b=~S:~S" 
    a (type-of a) b (type-of b)))
(do-query ((a b) "SELECT {fn CONCAT(tab.Text_,tab.Memo_)}, {fn ABS(tab2.Text2_)} 
 FROM {oj tab LEFT OUTER JOIN tab2 ON tab.id = tab2.ID};")
  (format t "~&a=~S:~S b=~S:~S" 
    a (type-of a) b (type-of b)))

(my-execute-command "{CALL tab_update_text(6+5)}")
(do-query ((a b) "{CALL qTabText_ByID(2,2+3)}") 
  (format t "~&a=~S b=~S" a b))

;;; Cursors
(defun print-row-status-array (cursor)
  (with-slots (odbc::row-descriptor) cursor
    (with-slots (odbc::array-size odbc::current-row-status) odbc::row-descriptor
      (if (> odbc::array-size 1)
          (dotimes (i odbc::array-size)
            (format t "~&row-status[~A]=~S" i
                    (case (odbc::desc-row-status odbc::row-descriptor i)
                      (#.odbc::SQL_ROW_SUCCESS 'odbc::SQL_ROW_SUCCESS)
                      (#.odbc::SQL_ROW_SUCCESS_WITH_INFO 'odbc::SQL_ROW_SUCCESS_WITH_INFO)
                      (#.odbc::SQL_ROW_UPDATED 'odbc::SQL_ROW_UPDATED)
                      (#.odbc::SQL_ROW_ADDED   'odbc::SQL_ROW_ADDED)
                      (#.odbc::SQL_ROW_ERROR   'odbc::SQL_ROW_ERROR)
                      (#.odbc::SQL_ROW_DELETED 'odbc::SQL_ROW_DELETED) 
                      (#.odbc::SQL_ROW_NOROW   'odbc::SQL_ROW_NOROW)
                      (otherwise (odbc::desc-row-status odbc::row-descriptor i)))))
          (format t "~&(array-size=1) : current-row-status=~S"
                  odbc::current-row-status)))))

(odbc::%sql-get-attribute :hdbc (odbc::handle o) odbc::SQL_ATTR_AUTOCOMMIT)
(setq lq (sql:open-cursor [select [*] :from [class-table]]
                           :database L
                           :limit 2
                           ;:cursor-type :keyset-driven
                           ;:concurrency :optimistic
                           :rowset-size 1
                          ))
(setq lq2 (sql:open-cursor [select [id] [bigint_] ;  [*]
                           :from [mytab]]
                           :database L
                           ;:cursor-type :keyset-driven
                           :concurrency :optimistic
                           :rowset-size 1))
(sql:fetch-rows  lq :count 1 :flatp nil)
(sql:fetch-rows  lq2 :count 1 :flatp nil)
(odbc::set-cursor-position oq :next)
(odbc::set-cursor-position pq2 :prior)
(odbc::set-cursor-position oq :last)
(odbc::set-cursor-position oq :relative :offset -4)
(odbc::set-cursor-position oq :absolute :offset 2)
(odbc::set-cursor-position oq :bookmark :offset 4)
(sql:fetch-rows oq :count 1)
(odbc::%sql-fetch (odbc::handle aq))
(odbc::%sql-fetch-scroll (odbc::handle aq) :relative :offset 0)
(odbc::%sql-delete-record (odbc::handle oq) 1)
(odbc::%sql-update-record (odbc::handle oq) 1)

(odbc::%sql-set-attribute :hstmt (odbc::handle oq) odbc::SQL_ATTR_ROW_STATUS_PTR
                            (odbc::desc-array-status-ptr (odbc::row-descriptor oq)))
(print-row-status-array oq)
(odbc::%sql-refresh-record (odbc::handle oq) 1)
(sql:current-row-status oq)
(sql:current-row-number oq)
(odbc::%sql-get-attribute :hstmt (odbc::handle oq) odbc::SQL_ATTR_ROW_NUMBER)
;; row number in entire result set, not in rowset => works in Oracle!
(odbc::%sql-get-attribute :hstmt (odbc::handle oq) odbc::SQL_ATTR_CONCURRENCY)
 ;=>3 (SQL_CONCUR_ROWVER)
(odbc::%sql-get-attribute :hstmt (odbc::handle oq) odbc::SQL_ATTR_KEYSET_SIZE) ;=>0

(sql:update-records oq :attributes '([job] [hiredate] [sal])
                       :values `(,(format nil "Upd. ~D" (random 100))
                                 ,(get-universal-time)
                                 56.789)
                       :where 104)
(sql:insert-records :into oq
                    :attributes '([empno] [ename] [hiredate] [sal])
                    :values `(122
                              ,(format nil "Added ~D" (random 100))
                              ,(lt:current-timestamp)
                              99.9))
;Message: [Microsoft][ODBC driver for Oracle][Oracle]ORA-00001:    (SCOTT.PK_EMP). ???

(sql:delete-records :from oq) ; :where 515)
(sql:close-statement lq2)
(sql:commit)

;;; The driver seems to fail to deliver long column data when rowset-size > 1
;;; SQLSetPos followed by SQLGetData crashes.
(setq oc (ystok.sql.sys:db-open-cursor o [select [ROWID] 
                                  [id] [empno] [char_] [smallint_] [date_] [double_]
                                  [raw_] [longtext_] [clob_] [blob_] 
                                                 :from [mytab]]
                                 :cursor-type :keyset-driven
                                 :concurrency :optimistic
                                 :rowset-size 1
                                 :start-column 1 ;0 bookmarks are not supported!
                                 ))
(odbc::%sql-get-attribute :hstmt (odbc::handle oc) odbc::SQL_ATTR_QUERY_TIMEOUT)
(odbc::%sql-set-attribute :hstmt (odbc::handle oc) odbc::SQL_ATTR_QUERY_TIMEOUT 1)


(sql:fetch-rows oc :count 4 :flatp nil)
(sql:fetch-rows oc :count nil)
(odbc::set-cursor-position oc :absolute :offset 1)
(odbc::set-cursor-position oc :relative :offset 0)
(odbc::set-cursor-position oc :prior)
(sql:update-records oc :attributes '([date_] [char_] [clob_])
                       :values `(,(get-universal-time)
                                 ,(format nil "   ~D" (random 100))
                                 "long updated via cursor"))
(odbc::%sql-refresh-record (odbc::handle oc) 0)
(print-row-status-array oc)

(sql:insert-records :into oc
      :attributes '([id] [date_] [char_]) ; [clob_])
      :values `(144
                ,(get-universal-time)
                ,(format nil "   ~D" (random 100))
                )) ;"long inserted via cursor"))
;;    ROWID .
(sql:close-statement oc)
(sql:cancel-statement oc)
(sql:commit)



