;;; -*- Mode: Lisp; -*-
;;; YstokSQL - Common Lisp ODBC interface 
;;; Copyright (c) 2002-2005 Dr. Dmitriy Ivanov. All rights reserved.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Foreign function compatibility module - Package definition

(in-package :cl-user)

(defpackage :ystok.ffc
  (:nicknames :ffc)
  (:use :common-lisp)
  #+lispworks4.4 (:import-from :fli "*NULL-POINTER*")
  (:export 
    "*FOREIGN-MODULE*" 
    "*FOREIGN-EF*" 
    #+win32 "*FOREIGN-CODE-PAGE*"
    "INITIALIZE-FFC-LOCALE"

    ;; SQL types
    "SQL-BYTE"
    "SQL-CHAR"
    "SQL-CHAR-PTR"
    "SQL-WCHAR"
    "SQL-DOUBLE"
    "SQL-HANDLE" 
    "SQL-HANDLE-PTR"
    "SQL-INTEGER"
    "SQL-OCTET"
    "SQL-POINTER"
    "SQL-REAL"
    "SQL-RETURN"
    "SQL-SMALLINT"
    "SQL-SCHAR"
    "SQL-UINTEGER"
    "SQL-USMALLINT"
    "STRING-PTR" 

    ;; Makers and ODBC specification convertors
    ;"%AREF"
    "%ADDRESS-TO-POINTER"
    ;"%COPY-POINTER"
    "%DECF-PTR"
    "%DISPOSE-PTR"
    "%FILL-VECTOR"
    "%FOREIGN-SLOT"
    "%FOREIGN-SLOT-POINTER"
    "%GET-INTEGER"
    "%GET-PTR"
    "%GET-SMALLINT"
    "%GET-STRING"
    "%GET-USMALLINT"
    "%GET-UINTEGER"
    "%INCF-PTR"
    "%MAKE-STRUCT"
    "%NEW-PTR"
    "%NEW-VECTOR"
    "*NULL-POINTER*"
    "%NULL-PTR-P"
    "%POINTER-TO-ADDRESS"
    ;"%PUT-INTEGER"
    ;"%PUT-SMALLINT"
    ;"%PUT-UINTEGER"
    ;"%PUT-USMALLINT"
    "%PTR-EQL"
    "+SQL-NULL-HANDLE+"
    "%SVREF"
    "WITH-DYNAMIC-POINTER"

    ;; Buffer to/from Lisp converting
    "%BUFFER-INTO-VECTOR"
    "%GET-CHAR"
    "%GET-CSTRING"
    "%GET-WSTRING"
    "%NEW-CSTRING" 
    "%PUT-STRING"
    "%PUT-WSTRING"
    "%GET-SLONG"
    "%PUT-SLONG"
    "%GET-ULONG"
    "%PUT-ULONG"
    "%GET-SSHORT"
    "%PUT-SSHORT"
    "%GET-USHORT"
    "%PUT-USHORT"
    "%GET-SINGLE"
    "%PUT-SINGLE"
    "%GET-DOUBLE"
    "%PUT-DOUBLE"
    "%GET-BIT"
    "%PUT-BIT"
    "%GET-BYTE"
    "%PUT-BYTE"
    "%GET-OCTET"
    "%PUT-OCTET"
    "%NEW-BINARY"
    "%GET-BINARY"
    "%PUT-BINARY"

    ;; High-level macros and utilities
    "DEFINE-FOREIGN-FUNCTION" 
    "DEFINE-FOREIGN-STRUCT"
    "%ENSURE-HWND" 
    "WITH-CSTR"		; short version of WITH-CSTRINGS
    "WITH-CSTRINGS"
    "WITHOUT-SCHEDULING"
    ;"%WITH-SQL-POINTER" 
    "WITH-TEMPORARY-ALLOCATION"
  ))
