;;;-*- Mode: Lisp; Encoding: (win32:code-page :id 1251) -*-
;;; YstokSQL - Common Lisp ODBC interface - Multi-threading tests

(in-package :sql.test)

(locally-enable-sql-reader-syntax)

(defmethod test-mp (env-type database &optional (cycles 100))
  (let ((mp:*process-initial-bindings*
         (cons '(*error-output* . *error-output*) mp:*process-initial-bindings*))
        (height 2.1))
    (format *error-output* "~&*** Multiprocessing in 3 threads ~d cycles" cycles)
    (mp:process-run-function "YSQL.TEST Thread 2" ()
                             'test-thread-2 env-type database cycles)
    (mp:process-run-function "YSQL.TEST Thread 3" ()
                             'test-thread-3 env-type database cycles)
    (test-no-error
      (dotimes (i cycles t)
        (incf height 0.001)
        ;(test  height
              (progn (sql:update-records [employee] :columns [height] :values height
                                         :where [= [emplid] 7])
                (sleep 0.01)
                (first (select [max [height]] :from [employee] :flatp t)))
       ) ;:test #'equalp
	:announce t      
	:reported-form :mp/thread-1/max)))
  
(defmethod test-thread-2 (env-type database &optional cycles)
  (let ((height 2.2))
    (test-no-error
      (dotimes (i cycles)
        (incf height 0.001)
        ;(test height
          (progn (sql:update-records [employee] :columns [height] :values height
                                     :where [= [emplid] 7])
            (sleep 0.01)
            (first (select [max [height]] :from [employee] :flatp t)))
      )    ;:test #'equalp
      :announce t      
      :reported-form :mp/thread-2/max)))

(defmethod test-thread-3 (env-type database &optional cycles)
  (let ((height 2.3))
    (test-no-error
      (dotimes (i cycles)
        (incf height 0.001)
        ;(test height
          (progn (sql:update-records [employee] :columns [height] :values height
                                     :where [= [emplid] 7])
            (sleep 0.01)
            (first (select [max [height]] :from [employee] :flatp t)))
      )    ;:test #'equalp
      :announce t      
      :reported-form :mp/thread-3/max)))


(restore-sql-reader-syntax-state)

#|
(test-mp :odbc *default-database*)
|#
